SystemOrganization addCategory: #'IRDA2013-Searching'!
SystemOrganization addCategory: #'IRDA2013-Searching-Tests'!

CircleMorph subclass: #I2SVisualNode
	instanceVariableNames: 'node parentEdge childEdges visualization valueMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2SVisualNode subclass: #I2SVisualBlankNode
	instanceVariableNames: 'parent parentChildNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SVisualBlankNode class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/22/2013 12:09:48.098'!
newOn: aVisualization
	| a |
	a := self new.
	a visualization: aVisualization.
	a draw.
	^a.! !

!I2SVisualBlankNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/22/2013 11:39:27.357'!
draw
	self color: Color transparent.
	self borderColor: self class defaultNodeColor.
	self borderWidth: 2.! !

!I2SVisualBlankNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/22/2013 11:33:18.555'!
drawChildrenWithDepth: depth! !

!I2SVisualBlankNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 12:21:13.017'!
initialize
	super initialize.
	
	self on: #click send: #onClick to: self. ! !

!I2SVisualBlankNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 10:43:03.98'!
isBlank
	^true! !

!I2SVisualBlankNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 16:26:58.247'!
onClick
	self visualization choseLeaf: self.! !

!I2SVisualBlankNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 10:45:15.113'!
parent
	^parent! !

!I2SVisualBlankNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 10:45:13.941'!
parent: aVisualNode
	parent := aVisualNode.! !

!I2SVisualBlankNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 10:45:36.845'!
parentChildNumber
	^parentChildNumber! !

!I2SVisualBlankNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 10:45:58.199'!
parentChildNumber: aNumber
	parentChildNumber := aNumber.! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 15:25:40.439'!
blankNodeWidth
	^40! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 15:45:39.541'!
defaultActiveNodeColor

	^Color green! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 15:26:38.883'!
defaultAnimationDuration

	^ 400! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:10:59.158'!
defaultNodeColor

	^Color orange ! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/15/2013 12:19:35.238'!
levelHeight
	^20! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/22/2013 11:49:19.524'!
newWithNode: aNode on: aVisualization
	^self newWithNode: aNode renderDepth: Float infinity on: aVisualization.! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 10:36:20.82'!
newWithNode: aNode renderDepth: aNumber on: aVisualization
	| a |
	
	aNode ifNil:[
		a := I2SVisualBlankNode newOn: aVisualization.
	] ifNotNil: [
		a := self new.
		a node: aNode.
		a visualization: aVisualization.
		a visualization setVisualNode: a for: aNode.
	
		a draw.
		((aNumber > 1) and: (aNode hasChildren or: (aVisualization drawNil))) ifTrue: [
			a drawChildrenWithDepth: aNumber. 
		].
		a setupBalloon.
	].
	^a! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 15:26:55.253'!
nodeSpace

	^20! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 13:05:24.766'!
addChildEdge: anEdge

	childEdges add: anEdge.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 15:59:41.022'!
arrangeChildren: children withOffset: offset
	| o |

	o := offset.

	children do: [:child |
		child isNil ifTrue: [
			o := o + self class blankNodeWidth + self class nodeSpace.
			childEdges add: nil.
		] 
		ifFalse: [
			|x y edge|
			"x := (offset + (child fullBounds width / 2))."
			x := (o + (0 - (child fullBounds topLeft x))).
			y := self class levelHeight + self bounds height.
			child position: x@y.
			o := o + child fullBounds width + self class nodeSpace.
			self addMorph: child.
			"the line"
			edge := (LineMorph 
					from: self bounds bottomCenter 
					to: child bounds topCenter
					color: Color black 
					width: 5).
			child parentEdge: edge.	
			self childEdges add: edge.
			self addMorph: edge.
		]
	].! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:20:13.994'!
calculateOffset: children
	| totalWidth l r b |

	"documented on https://rialgar.de/IRDA2013Doku/page.xhtml"

	totalWidth := self calculateTotalWidth: children.
	
	l := 0. r := 0. b := 0.
	
	(children first) ifNotNil: [
		l := 0 - ((children first) fullBounds left).
	].
	(children last)  ifNotNil:[
		r := ((children last fullBounds right) - (children last bounds right)).
	].
	b := self bounds width.
	
	^ 0 - ((totalWidth+l-r-b)/2).! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:04:50.051'!
calculateTotalWidth: children
	| totalWidth |
	totalWidth := 0.
	
	children do:[ :child |
			child isNil ifTrue: [
				totalWidth := totalWidth + self class blankNodeWidth.
			] ifFalse: [
				totalWidth := totalWidth + (child fullBounds width).
			].
		].
	
	"between childs there should be some space, so we add this to the total width"
	totalWidth := totalWidth + (((children size) - 1) * self class nodeSpace).
	
	^totalWidth! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 13:34:44.775'!
childEdges
	
	^ childEdges! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:43:34.404'!
draw
	self updateColor.
	self drawValue.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:02:51.694'!
drawChildren 
	self drawChildrenWithDepth: Float infinity.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 17:27:17.271'!
drawChildrenWithDepth: aNumber 
	| children offset |
	children := self gatherChildrenWithDepth: aNumber.
	
	offset := self calculateOffset: children.
	
	self arrangeChildren: children withOffset: offset.
! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 10:23:55.808'!
drawValue
	| textMorph |
	self valueMorph ifNotNil: [
		self valueMorph delete.
	].
	textMorph := TextMorph new.
	textMorph contents: (((self node getValueAt: 1) asString) truncateTo: 4).
	textMorph lock: true.
	self valueMorph: textMorph.
	self addMorph: textMorph.
	textMorph position: 10@10.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 13:26:22.498'!
edges

	| allEdges |
	allEdges := OrderedCollection new.
	allEdges addAll: childEdges.
	parentEdge ifNotNil: [allEdges add: parentEdge].
	
	^ allEdges ! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 10:47:09.177'!
gatherChildrenWithDepth: aNumber
	| children |
	children := OrderedCollection new.
	
	(node children) 
		do: [ :child || a |
			child isNil 
			ifTrue: [
				self visualization drawNil ifTrue: [
					a := I2SVisualBlankNode newOn: self visualization.
					a parent: self.
					a parentChildNumber: children size + 1.
					children add: a.
				] ifFalse: [
					children add: nil.
				].
			] 
			ifFalse: [
				a := I2SVisualListNode newWithNode: child renderDepth: (aNumber - 1) on: self visualization.
				children add: a.
			].
		].
	
	^children.
! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 10:32:18.255'!
hideContent
	self valueMorph ifNotNil: [
		self valueMorph delete.
		self valueMorph: nil.
		self balloonText: nil.
	].! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:32:28.093'!
initialize 
	
	super initialize.
	childEdges := OrderedCollection new.
	self on: #click send: #onClick to: self.
	! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 10:43:25.508'!
isBlank
	^false! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:50.635'!
node
 ^node! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:54.969'!
node: aNode
 node := aNode! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:33:11.592'!
onClick
	self visualization clickedOn: self.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dg 5/30/2013 14:16:07.64'!
parentEdge

	^ parentEdge! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dg 5/30/2013 14:15:49.976'!
parentEdge: anEdge

	parentEdge := anEdge! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 16:04:25.825'!
position: aPoint

	super position: aPoint.
	parentEdge ifNotNil:[
		parentEdge setVertices: 
			{(parentEdge vertices at: 1 ). (self bounds topCenter) }.		
	].
	childEdges do: [ :edge |
		
		edge ifNotNil: [
		edge setVertices:
			{(self bounds bottomCenter). (edge vertices at: 2) }
			].
	].
	
	^self! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 10:35:49.175'!
setupBalloon
	self balloonText: (self node getValueAt: 1) asString.! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:42:52.57'!
updateColor
	(node color) ifNotNil:
		[self color: node color]
	ifNil: [
		(self visualization activeNode = self node) ifTrue: [
			self color:
				self class defaultActiveNodeColor.
		] ifFalse: [
			self color: 
				self class defaultNodeColor.
		]
	].! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 10:23:02.153'!
valueMorph
	^valueMorph! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 10:23:15.021'!
valueMorph: aMorph
	valueMorph := aMorph! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:24:24.415'!
visualization 
	
	^visualization
	! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:24:45.659'!
visualization: aVisualization
	
	visualization := aVisualization.
	! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 15:25:33.661'!
walkToPosition: aPoint

	self walkToPosition: aPoint then: []! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 15:26:42.588'!
walkToPosition: aPoint then: aBlock

		(AnimPropertyAnimation
		on: self
		property: #position
		start: self position
		end: aPoint
		duration: self class defaultAnimationDuration)
		finishBlock: aBlock;
		register;
		start: #deleteWhenFinished.! !

Object subclass: #I2SChapter
	instanceVariableNames: 'name tasks currentTaskNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SChapter class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:39:58.632'!
newWithTasks: aCollection andName: aName
	^ self new
		tasks: aCollection;
		name: aName! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 17:00:42.613'!
currentTask
	self tasks ifEmpty: [
		^nil
	].
	
	(self tasks size > self currentTaskNumber) ifTrue:
	[
		^self tasks at: self currentTaskNumber.
	].

	^self tasks last. ! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:25:10.61'!
currentTaskNumber
	^ currentTaskNumber! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:24:36.767'!
currentTaskNumber: aNumber
	currentTaskNumber := aNumber.! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 16:59:26.195'!
finished
	^(self currentTaskNumber > self tasks size)! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 16:57:29.353'!
initialize
	self currentTaskNumber: 1.
	self tasks: {}.! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:25:05.881'!
name
	^ name! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:23:48.232'!
name: aName
	name := aName.! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 16:59:51.13'!
nextTask
	self currentTaskNumber: self currentTaskNumber+1.

	^self currentTask.! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:50:12.616'!
tasks
	^tasks! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:23:43.203'!
tasks: aCollection
	tasks := aCollection.! !

!I2SChapter methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 11:54:31.802'!
unlockAll
	self currentTaskNumber: self tasks size.! !

Object subclass: #I2SListNode
	instanceVariableNames: 'parent list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SListNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:20:16.637'!
newWithList: aList
	|a|
	a := self new.
	a list: aList.
	^a! !

!I2SListNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:52:55.249'!
addedChild: a to: b at: c
self emit.! !

!I2SListNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 15:02:53.009'!
createLeftPart: aValue
	|newList|
	newList := OrderedCollection new.
	list do: [:ea |
		ea = aValue ifTrue: [
			^self class newWithList: (newList asArray)
		].
		newList add: ea.
	].
	^self class newWithList: (newList asArray)! !

!I2SListNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 15:04:47.969'!
createRightPart: aValue
	|newList flag|
	newList := OrderedCollection new.
	flag := false.
	list do: [:ea |
		flag ifTrue: [
			newList add: ea.
		].		
		ea = aValue ifTrue: [
			flag := true.
		].
	].
	^self class newWithList: (newList asArray)! !

!I2SListNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:22:24.7'!
isListNode
	^true! !

!I2SListNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:19:33.852'!
list
	^list! !

!I2SListNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:19:35.276'!
list: aList
	list := aList! !

!I2SListNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:18:55.492'!
parent
	^parent! !

!I2SListNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:18:58.95'!
parent: aNode
	parent := aNode! !

!I2SListNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:53:09.513'!
removedChild: a from: b at: c
self emit.! !

Object subclass: #I2STask
	instanceVariableNames: 'name description hints unveiled completed visualization clickCount userCode userCodeSignature userCodeRunner isCodingTask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2STask subclass: #I2SAddTask
	instanceVariableNames: 'value visualizationClass list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SAddTask class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 14:44:36.057'!
newWithVisualizationClass: aClass andValue: aValue andList: aList
	| a |
	a := self basicNew.
	a visualizationClass: aClass.
	a value: aValue.
	a list: aList.
	
	a initialize.
	^a.! !

!I2SAddTask methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 18:40:40.418'!
chooseLeaf: aVisualBlankNode
	| p root |
	root := self visualization rootNode.
	root ifNil: [
		root := self visualization node.
		[root parent isNil] whileFalse: [
			root := root parent.
		].
	].
	p := root findPlaceForValue: self value.
	((p first = aVisualBlankNode parent node)
		and: (p last = aVisualBlankNode parentChildNumber)
	) ifTrue: [
		self userCodeRunner stop.
		self completed: true.
	] ifFalse: [
		|anim|
		aVisualBlankNode fillStyle: Color white.
		anim := I2SColorAnimation new.
		anim duration: 1000.
		anim startValue: Color red.
		anim endValue: (Color red alpha: 0).
		anim target: aVisualBlankNode.
		anim property: #fillStyle.
		anim finishBlock: [Transcript showln: 'finish'].
		anim start: #deleteWhenFinished.
		anim register.
	].! !

!I2SAddTask methodsFor: 'nil' stamp: 'benjamin.siegmund 6/26/2013 12:14:20.191'!
initialize
	super initialize.
	
	self updateDescription.! !

!I2SAddTask methodsFor: 'nil' stamp: 'benjamin.siegmund 6/23/2013 13:30:52.431'!
list
	^list.! !

!I2SAddTask methodsFor: 'nil' stamp: 'benjamin.siegmund 6/23/2013 13:31:09.102'!
list: aCollection
	list := aCollection.! !

!I2SAddTask methodsFor: 'nil' stamp: 'dustin.glaeser 6/26/2013 15:44:47.331'!
setUpVisualization
	|v|
	v := self visualizationClass newWithList: self list.
	v drawNil: true.
	v updateTree.
	
	^v! !

!I2SAddTask methodsFor: 'nil' stamp: 'benjamin.siegmund 6/23/2013 16:16:21.594'!
setupConnections
	self
		connect: self visualization
		signal: #choseLeaf:
		toSelector: #chooseLeaf:.! !

!I2SAddTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 12:14:14.15'!
updateDescription
	self description: 'Insert the value ', self value, ' into the search tree, please!!'.! !

!I2SAddTask methodsFor: 'nil' stamp: 'benjamin.siegmund 6/23/2013 13:25:33.876'!
value
	^value! !

!I2SAddTask methodsFor: 'nil' stamp: 'benjamin.siegmund 6/23/2013 14:56:08.008'!
value: aNumber
	value := aNumber.! !

!I2SAddTask methodsFor: 'nil' stamp: 'benjamin.siegmund 6/23/2013 14:15:02.041'!
visualizationClass
	visualizationClass ifNil: [
		visualizationClass := I2SVisualization.
	]. 
	^visualizationClass.! !

!I2SAddTask methodsFor: 'nil' stamp: 'benjamin.siegmund 6/23/2013 13:27:54.554'!
visualizationClass: aClass
	visualizationClass := aClass.! !

I2SAddTask subclass: #I2SRandomAddTask
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SRandomAddTask class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 14:04:41.065'!
newWithVisualizationClass: aClass andSize: aSize
	| task |
	task := self basicNew.
	task visualizationClass: aClass.	
	task size: aSize.
	
	^ task initialize	! !

!I2SRandomAddTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 12:31:23.734'!
getRandomList 
	^ (Random new next: self size) collect: [ :element | 
		(element * 1000) asInteger ].! !

!I2SRandomAddTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 12:26:57.827'!
getRandomValue
	^ (Random new next * 1000) asInteger.! !

!I2SRandomAddTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 14:07:24.546'!
reset
	self list: self getRandomList.
	self value: self getRandomValue.
	
	super reset.! !

!I2SRandomAddTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 12:31:26.405'!
size
	^size! !

!I2SRandomAddTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 12:31:39.925'!
size: aNumber
	size := aNumber.! !

I2STask subclass: #I2SRotateTask
	instanceVariableNames: 'list visualizationClass maxDepth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SRotateTask class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:17:16.432'!
newWithVisualizationClass: aClass andList: aList
	| a |
	a := self basicNew.
	a visualizationClass: aClass.
	a list: aList.
	a maxDepth: (aList size log: 2) ceiling.
	
	a initialize.
	^a.! !

!I2SRotateTask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:09:52.71'!
initialize
	super initialize.
	self updateDescription.! !

!I2SRotateTask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:21:01.776'!
list
	^list! !

!I2SRotateTask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:21:00.683'!
list: aList
	list := aList.! !

!I2SRotateTask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:15:24.928'!
maxDepth
	^maxDepth.! !

!I2SRotateTask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:15:26.925'!
maxDepth: aNumber
	maxDepth := aNumber! !

!I2SRotateTask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:50:26.992'!
setUpVisualization
	| vis |
	vis := self visualizationClass newWithList: self list.
	vis maxDepth: self maxDepth.
	vis ignoreSelection: false.
	vis updateTree.
	^vis! !

!I2SRotateTask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:10:36.622'!
updateDescription
	self description: 'Balance this Binary Search Tree, please!!'.! !

!I2SRotateTask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:13:55.764'!
visualizationClass 
	^visualizationClass! !

!I2SRotateTask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:14:10.544'!
visualizationClass: aClass
	visualizationClass := aClass.! !

I2STask subclass: #I2SSearchTask
	instanceVariableNames: 'value visualizationClass list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2SSearchTask subclass: #I2SRandomSearchTask
	instanceVariableNames: 'size isSorted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SRandomSearchTask class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2013 16:20:28.056'!
newSortedWithVisualizationClass: aClass andSize: aSize
	
	| task |
	task := self
		newWithVisualizationClass: aClass
		andSize: aSize.
	task isSorted: true.
	
	^ task initialize	! !

!I2SRandomSearchTask class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2013 16:23:21.82'!
newWithVisualizationClass: aClass andSize: aSize
	| task |
	task := self basicNew.
	task visualizationClass: aClass.	
	task size: aSize.
	task isSorted: false.
	
	^ task initialize	! !

!I2SRandomSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 12:28:59.945'!
getRandomList
	^ (Random new next: self size) collect: [ :element | 
		(element * 1000) asInteger ].! !

!I2SRandomSearchTask methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2013 17:23:20.355'!
getRandomTargetValueFrom: aList
	| r targetValue |
	
	r := Random new.
	"The target value must not be at index 1"
	targetValue := (aList at: ((r next) * (self size-1)) + 2) asInteger.
	
	^ targetValue
	! !

!I2SRandomSearchTask methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2013 16:21:41.541'!
isSorted 
	^ isSorted
	! !

!I2SRandomSearchTask methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2013 16:19:19.845'!
isSorted: aBoolean
	isSorted := aBoolean.! !

!I2SRandomSearchTask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 11:45:07.134'!
reset
	| list |
	
	list := self getRandomList.

	"make sure that if we are a task for a treesectionmorph, we always have a leaf as target value"
	self visualizationClass = I2STreeSectionMorph ifTrue: [
		self value: list last.
	] ifFalse: [
		self value: (self getRandomTargetValueFrom: list).
	].
	self list: list.
	self isSorted ifTrue: [self list sort].
	super reset.! !

!I2SRandomSearchTask methodsFor: 'accessing' stamp: 'dustin.glaeser 6/23/2013 14:43:18.291'!
size
	^ size! !

!I2SRandomSearchTask methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2013 14:46:00.182'!
size: aSize
	size := aSize.! !

!I2SSearchTask class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 17:03:41.292'!
newWithVisualizationClass: aClass andValue: aValue andList: aList
	| a |
	a := self basicNew.
	a visualizationClass: aClass.
	a value: aValue.
	a list: aList.
	
	a initialize.
	^a.! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 16:08:06.666'!
checkValue: aValue
	(aValue = self value) ifTrue: [
		self completed: true.
	].! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2013 15:29:00.531'!
initialize
	super initialize.
	self updateDescription.
	! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:35:39.547'!
list
	^list! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:35:21.437'!
list: aList
	list := aList.! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:47:06.378'!
setUpVisualization
	^self visualizationClass newWithList: self list! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:55:15.996'!
setupConnections
	self
		connect: self visualization 
		signal: #valueSelected:
		toSelector: #checkValue:! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2013 15:29:01.76'!
updateDescription

	self description: (('Find the Number ', self value), ', please!!').! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:35:43.12'!
value
	^value! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:19:14.95'!
value: aValue
	value := aValue.! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:37:37.013'!
visualizationClass
	visualizationClass ifNil:
	[
		visualizationClass := I2SListMorph.
	].
	^visualizationClass! !

!I2SSearchTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:36:04.552'!
visualizationClass: aClass
	visualizationClass := aClass.! !

!I2STask class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/19/2013 16:21:31.425'!
defaultUserCode

	^ 
		'(aValue < self value) ifTrue: [self goLeft] ifFalse: [self goRight].'! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:02:44.736'!
addHint: aString
	self hints add: aString.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:56:40.108'!
clickCount
	^clickCount.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:56:32.094'!
clickCount: aNumber
	clickCount := aNumber.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 12:00:00.581'!
completed
	^completed! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 12:00:09.436'!
completed: aBoolean
	completed := aBoolean.
	self emitAlways.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:01:18.093'!
description
	^ description! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:01:35.016'!
description: aString
	description := aString.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:05:16.263'!
hints
	^hints! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:02:21.444'!
hints: aCollection
	hints := aCollection.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:59:08.453'!
incrementClickCount
	self clickCount: (self clickCount + 1)! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 11:54:16.269'!
initialize
	super initialize.
	
	self description: ''.
	self name: ''.
	self userCodeSignature: 'findValue: aValue'.
	self userCode: self class defaultUserCode.
	self userCodeRunner: I2SUserCodeRunner new.
	self isCodingTask: false.
	
	self hints: OrderedCollection new.
	
	self reset.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 11:51:39.989'!
isCodingTask
	^isCodingTask.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 11:55:38.803'!
isCodingTask: aBoolean
	isCodingTask := aBoolean.
	self visualization ifNotNil: [
		self visualization ignoreMouse: aBoolean.
	].! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:44:33.582'!
name
	^name! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:44:31.052'!
name: aString
	name := aString.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:31:55.545'!
nextHint
	(self hints size = 0) ifTrue: [
		^ 'there are no hints'.
	].
	(self unveiled < self hints size) ifFalse: [
		self unveiled: 0.
	].
		self unveiled: self unveiled + 1.
		^self hints at: self unveiled! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2013 16:13:31.612'!
reset
	
	self userCodeRunner stop.
	
	self unveiled: 0.
	self completed: false.
	self visualization: self setUpVisualization.
	
	self clickCount: 0.
	self
		connect: visualization
		signal: #actionPerformed
		toSelector: #incrementClickCount .! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 11:52:46.666'!
setUpVisualization
	self subclassResponsibility.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:19:30.507'!
setupConnections! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:05:21.006'!
unveiled
	^unveiled! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:05:51.846'!
unveiled: aNumber
	unveiled := aNumber.! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 16:01:31.282'!
updateDescription! !

!I2STask methodsFor: 'User Code' stamp: 'dg 6/12/2013 15:19:08.942'!
userCode
	^ userCode! !

!I2STask methodsFor: 'User Code' stamp: 'dg 6/12/2013 15:19:09.804'!
userCode: aString
	userCode := aString! !

!I2STask methodsFor: 'User Code' stamp: 'dustin.glaeser 6/19/2013 15:03:02.943'!
userCodeRunner
	^ userCodeRunner! !

!I2STask methodsFor: 'User Code' stamp: 'dustin.glaeser 6/19/2013 15:13:40.434'!
userCodeRunner: aUserCodeRunner

	userCodeRunner := aUserCodeRunner.
	userCodeRunner task: self.! !

!I2STask methodsFor: 'User Code' stamp: 'dg 6/12/2013 16:06:01.48'!
userCodeSignature
	^ userCodeSignature! !

!I2STask methodsFor: 'User Code' stamp: 'dg 6/12/2013 15:19:10.666'!
userCodeSignature: aString
	userCodeSignature := aString! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 11:52:01.239'!
visualization
	^visualization! !

!I2STask methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 11:59:32.394'!
visualization: aVisualization
	visualization ifNotNil:[
		visualization disconnectAllSignals.	
	].
	visualization := aVisualization.
	aVisualization ignoreMouse: self isCodingTask.
	self setupConnections.
	self emitAlways.! !

I2STask subclass: #I2STestTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2STestTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 14:55:06.748'!
checkValue: aValue
	self completed: (aValue = 42).! !

!I2STestTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:22:34.962'!
checkValueOfNode: aNode
	self completed: (aNode value = 42).! !

!I2STestTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:04:43.962'!
initialize 
	super initialize.
	self description: 'Find the answer to life, the universe and everything!!'.
	self addHint: 'The answer is 42.'. 
	self addHint: 'The question is unknown, though.'.! !

!I2STestTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:17:18.061'!
setUpVisualization
	| root r |
	r := Random new.
	root := I2SBinarySearchTreeNode newWithValue: (r next * 100) asInteger.
	(r next: 50) do: [ :ea |
		root addValue: (ea * 100) asInteger.
	].
	root addValue: 42.
	(r next: 50) do: [ :ea |
		root addValue: (ea * 100) asInteger.
	].
	^ I2STreeSectionMorph newWithNode: root.! !

!I2STestTask methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 14:54:51.16'!
setupConnections
	self
		connect: self visualization
		signal: #valueSelected:
		toSelector: #checkValue:.
		! !

Object subclass: #I2STreeNode
	instanceVariableNames: 'parent children numChildren values maxChildren maxValues color silent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2STreeNode subclass: #I2SBinaryTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2SBinaryTreeNode subclass: #I2SBinarySearchTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SBinarySearchTreeNode class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:35:29.029'!
newWithList: aList
	|node|
	node := self new.
	aList do: [:ea|
		node addValue: ea.	
	].
	^node.! !

!I2SBinarySearchTreeNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 16:10:51.987'!
randomTree

| a r |
 r := Random new.
 a := self newWithValue: (r next * 100) asInteger. 
0 to: 20 do: [ :i |
	a addValue: (r next * 100) asInteger.
].
 ^a! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:36:18.155'!
addValue: aValue
	self value ifNil: [
		self value: aValue.
		^self.
	].

	(self value > aValue) ifTrue:[
		self leftChild ifNil: [
				self leftChild: (I2SBinarySearchTreeNode newWithValue: aValue).
			] ifNotNil: [
				self leftChild addValue: aValue.
			].
		]ifFalse:[
			self rightChild ifNil: [
				self rightChild: (I2SBinarySearchTreeNode newWithValue: aValue).
			] ifNotNil: [
				self rightChild addValue: aValue.
			].
		]! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:56:17.112'!
find: aValue

	^(self findNodeForValue: aValue) isNil not! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:06.472'!
findNodeForValue: aValue

	(self value = aValue) ifTrue: [
		^self
	] ifFalse: [
		(self value > aValue) ifTrue:[
			self leftChild ifNil: [
				^nil
			] ifNotNil: [
				^self leftChild findNodeForValue: aValue
			]
		] ifFalse:[
			self rightChild ifNil: [
				^nil
			] ifNotNil: [
				^self rightChild findNodeForValue: aValue
			]
		]
	].! !

!I2SBinarySearchTreeNode methodsFor: 'nil' stamp: 'benjamin.siegmund 6/23/2013 15:19:31.267'!
findPlaceForValue: aValue
	(self value > aValue) ifTrue:[
		self leftChild ifNil: [
			^{self. 1}.
		] ifNotNil: [
			^self leftChild findPlaceForValue: aValue.
		].
	]ifFalse:[
		self rightChild ifNil: [
			^{self. 2}.
		] ifNotNil: [
			^self rightChild findPlaceForValue: aValue.
		].
	]! !

!I2SBinarySearchTreeNode methodsFor: 'initialize-release' stamp: 'benjamin.siegmund 5/15/2013 11:06:37.881'!
initialize

	super initialize.! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:30:16.149'!
leftMostAncestor 
	self leftChild ifNil: [
		^self
	] ifNotNil: [
		^self leftChild leftMostAncestor
	].! !

!I2SBinarySearchTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:31:02.453'!
remove: aValue
	| node |
	
	node := self findNodeForValue: aValue.
	node ifNotNil:[
		node rightChild ifNil:[ | child |
			child := node leftChild.
			node leftChild: nil.
			node parent replace: node with: child.
		] ifNotNil: [
			node leftChild ifNil:[ | child |
				child := node rightChild.
				node rightChild: nil.
				node parent replace: node with: child.
			] ifNotNil:[ | leaf child |
				leaf := node rightChild leftMostAncestor.
				node value: leaf value.
				child := leaf rightChild.
				leaf rightChild: nil.
				leaf parent replace: leaf with: child.
			]
		]
	]! !

!I2SBinaryTreeNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 16:24:05.099'!
randomTree

| a r |
 a := self new.
 r := Random new.
 a value: (r next * 100) asInteger.
 0 to: 20 do: [ :i |
	a addValueRandomly: (r next * 100) asInteger.
].
 ^a! !

!I2SBinaryTreeNode methodsFor: 'private' stamp: 'sebastian.stamm 5/30/2013 16:23:09.957'!
addValueRandomly: aValue

 | r |
 r := Random new.
 r next < 0.5 ifTrue: [
	self leftChild ifNil: [
		| a |
		a := self class new.
		a value: aValue.
		self leftChild: a.
	] ifNotNil: [
		self leftChild addValueRandomly: aValue.
	]
 ] ifFalse: [
	self rightChild ifNil: [
		| a |
		a := self class new.
		a value: aValue.
		self rightChild: a.
	] ifNotNil: [
		self rightChild addValueRandomly: aValue.
	]
 ]! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 16:34:28.432'!
initialize

	super initialize.
	self maxChildren: 2.
	self maxValues: 1.
	self children add: nil.
	self children add: nil.! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:37.869'!
leftChild

	^self getChildAt: 1! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:36:17.767'!
leftChild: aNode

	self leftChild ifNotNil: [
		self removeChildAt: 1.].
	
	aNode ifNotNil:[
		self addChild: aNode at: 1.].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:40.078'!
rightChild

	^self getChildAt: 2! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:36:25.394'!
rightChild: aNode
	
	self rightChild ifNotNil:[
		self removeChildAt: 2.].
	aNode ifNotNil:[
		self addChild: aNode at: 2.].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 17:33:16.117'!
rotateLeft	
	^self rotateLeftThen: [].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 17:53:54.24'!
rotateLeftThen: aBlock
	| p rc rlc |
	self rightChild ifNil: [
		self error: 'not allowed for this node'.
	].
	self willRotateTo: self rightChild.
	p := self parent.
	rc := self rightChild.
	rlc := self rightChild leftChild.
	
	p ifNotNil: [
		p beSilent.
	].
	rc beSilent.
	self rightChild: nil.
	rc leftChild: nil.
	p ifNotNil: [
		p replace: self with: rc.
	].
	self rightChild: rlc.
	rc leftChild: self.
	p ifNotNil: [
		p beNotSilent.
	].
	rc beNotSilent.
	
	self rotatedLeft: self then: aBlock.
	
	^self parent ! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 17:33:30.089'!
rotateRight
	^self rotateRightThen: [].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 17:54:21.896'!
rotateRightThen: aBlock
	| p lc lrc |
	self leftChild ifNil: [
		self error: 'not allowed for this node'.
	].
	self willRotateTo: self leftChild.
	p := self parent.
	lc := self leftChild.
	lrc := self leftChild rightChild.
	
	p ifNotNil: [
		p beSilent.
	].
	lc beSilent.
	self leftChild: nil.
	lc rightChild: nil.
	p ifNotNil: [
		p replace: self with: lc.
	].
	self leftChild: lrc.
	lc rightChild: self.
	p ifNotNil: [
		p beNotSilent.
	].
	lc beNotSilent.
	
	self rotatedRight: self then: aBlock.
	
	^self parent ! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 17:50:11.809'!
rotatedLeft: node then: aBlock
	self silent ifFalse: [
		self parent ifNil: [
			self emitAlways.
		] ifNotNil: [
			self parent rotatedLeft: node then: aBlock.
		].
	].! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 17:31:46.606'!
rotatedRight: node then: aBlock
	
	self silent ifFalse: [
		self parent ifNil: [
			self emitAlways.
		] ifNotNil: [
			self parent rotatedRight: node then: aBlock.
		].
	]! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:42.497'!
value
	^self getValueAt: 1! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 14:38:34.794'!
value: aValue
	self setValue: aValue at: 1.! !

!I2SBinaryTreeNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 17:29:54.014'!
willRotateTo: aNode
	self emit.! !

!I2STreeNode class methodsFor: 'constructors' stamp: 'benjamin.siegmund 5/29/2013 16:46:43.51'!
newWithValue: aValue
	| out |
	out := self new.
	out setValue: aValue at: 1.
	^out! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/19/2013 17:47:39.875'!
addChild: newRoot at: position
	(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.
	].
	
	newRoot ifNil:[
		^self
	].

	newRoot parent ifNotNil: [
		self error: 'node already has a parent'.
	].

	[children size < position] whileTrue:[
		children add: nil
	].

	(children at: position) ifNil: [
		children at: position put: newRoot.
		newRoot parent: self.
		self addedChild: newRoot to: self at: position.
		numChildren := numChildren+1.
	] ifNotNil: [
		self error: 'child already present.'
	].! !

!I2STreeNode methodsFor: 'signals' stamp: 'sebastian.stamm 6/19/2013 16:08:29.987'!
addedChild: newRoot to: parent at: position
self silent ifFalse:[
	self parent ifNil: [
		self emitAlways.
	] ifNotNil: [
		self parent addedChild: newRoot to: parent at: position
	].
].! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:16:17.093'!
beNotSilent
	self silent: false.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:16:00.949'!
beSilent
	self silent: true.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:07.532'!
children

^children! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:06:57.034'!
color

	^color! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:06:13.238'!
color: aColor
	
	color := aColor.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 17:45:46.758'!
copy
	| newObject |
	newObject := self class new.
	1 to: values size do:[ :i|
		newObject setValue: (self getValueAt: i) copy at: i.	
	].
	1 to: self children size do:[ :i|
		newObject addChild: (self getChildAt: i) copy at: i.	
	].
	^newObject.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 12:38:13.762'!
getChildAt: position
	(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].

	children size >= position ifTrue: [
		^children at: position] ifFalse: [
		^nil]! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:47:52.104'!
getValueAt: position
	(position < 1 or: position > maxValues) ifTrue: [
		self error: 'position out of bounds'].

	(values size >= position) ifTrue: [
		^values at: position] ifFalse:[
		^nil]! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:24.062'!
hasChildren

^numChildren > 0! !

!I2STreeNode methodsFor: 'initialize-release' stamp: 'benjamin.siegmund 6/12/2013 15:23:17.712'!
initialize
	silent := false.
	parent := nil.
	children := OrderedCollection new.
	values := OrderedCollection new.
	numChildren := 0.
	maxChildren := 10.
	maxValues := 9.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:23:25.087'!
isListNode
	^false! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:46:35.244'!
maxChildren

	^maxChildren! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:56:18.137'!
maxChildren: aNumber

	maxChildren := aNumber.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:46:37.916'!
maxValues

	^maxValues! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:55:05.223'!
maxValues: aNumber

	maxValues := aNumber.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/2/2013 15:41:30.94'!
numChildren

^numChildren! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/29/2013 16:46:40.214'!
parent

	^parent! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 14:02:41.641'!
parent: aNode

	parent := aNode.! !

!I2STreeNode methodsFor: 'accessing' stamp: 'sebastian.stamm 6/12/2013 12:03:52.143'!
removeChildAt: position
(position < 1 or: position > maxChildren) ifTrue: [
		self error: 'position out of bounds'.].
	
children size >= position ifTrue: [
	(children at: position) ifNotNil:[
		| child |
		child := children at: position.
		children at: position put: nil.
		child parent: nil.
		self removedChild: child from: self at: position.
		numChildren := numChildren-1.]]! !

!I2STreeNode methodsFor: 'signals' stamp: 'benjamin.siegmund 6/12/2013 15:17:13.817'!
removedChild: root from: parent at: position
self silent ifFalse:[
	self parent ifNil: [
		self emitAlways.
	] ifNotNil: [
		self parent removedChild: root from: parent at: position
	].
].! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 16:18:27.497'!
replace: child with: newChild
	1 to: children size do: [ :i |
		((self children	at: i) = child) ifTrue: [
			self removeChildAt: i.
			self addChild: newChild at: i.
		] 
	]! !

!I2STreeNode methodsFor: 'accessing' stamp: 'benjamin.siegmund 5/8/2013 11:53:59.231'!
setValue: aValue at: position
	(position < 1 or: position > maxValues) ifTrue: [
		self error: 'position out of bounds'.].

	[values size < position] whileTrue: [
		values add: nil].

	values at: position put: aValue.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:14:43.224'!
silent
	^silent.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 15:15:11.912'!
silent: aBoolean
	silent := aBoolean.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 17:37:22.205'!
visualization: aVisualNode

	visualization := aVisualNode.! !

Object subclass: #I2SUserCodeRunner
	instanceVariableNames: 'task executionList isRunning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SUserCodeRunner methodsFor: 'userMethods' stamp: 'dustin.glaeser 6/26/2013 18:41:02.077'!
findValue: aValue
(aValue < self value) ifTrue: [
	self hasLeftChild ifTrue: [
		self hasRightChild ifFalse: [self insertAsRightChild: aValue].
		self goLeft]		
	ifFalse: [self insertAsLeftChild: aValue]
] ifFalse: [
	self hasRightChild ifTrue: [
		self hasLeftChild ifFalse: [self insertAsLeftChild: aValue].
		self goRight]
	ifFalse: [self insertAsRightChild: aValue]
].! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 16:45:38.764'!
goLeft 

	executionList add: #goLeft.! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 11:39:37.847'!
goRight

	executionList add: #goRight.
	"task visualization goRight."! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 11:42:45.634'!
goUp 

	executionList add: #goUp.! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 16:45:57.612'!
hasLeftChild

	^ self task visualization node leftChild isNil not! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 17:06:45.657'!
hasRightChild

	^ self task visualization node rightChild isNil not! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 11:53:38.145'!
initialize 

	super initialize.
	executionList := OrderedCollection new.
	self isRunning: false.
	! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 18:16:29.417'!
insertAsLeftChild: aValue
"this works only on TreeSectionMorphs"
	self task chooseLeaf: 
		(self task visualization leftMorph).! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 18:16:31.002'!
insertAsRightChild: aValue
"this works only on TreeSectionMorphs"
	self task chooseLeaf: 
		(self task visualization rightMorph).! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 11:15:58.518'!
isRunning
	^isRunning! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 11:16:15.559'!
isRunning: aBoolean
	isRunning := aBoolean.! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 16:47:52.368'!
replay
	| action |

	(executionList size = 0) ifTrue: [
		self isRunning ifTrue: [
			self step].
		^self].
	
	action := executionList first.
	action := (action, 'Then:') asSymbol.
	Transcript showln: action.
	task visualization perform: action with: [self replay].
	
	executionList removeFirst.! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 18:03:19.574'!
run
	self isRunning ifTrue: [
		self stop.
	] ifFalse: [
		self isRunning: true.
		self step.
	].! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 18:14:31.625'!
step 
	(self task visualization isInWorld) ifFalse: [
		self isRunning: false.
		^self].
	
	(self isRunning) ifFalse: [
		^self].
	
	executionList := OrderedCollection new.
	self findValue: self task value.
	Transcript showln: executionList.
	self replay.! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 10:52:07.496'!
stepTime
	"Answer the desired time between steps in milliseconds."

	^ 1000! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 12:03:41.519'!
stop
	self isRunning: false.! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/19/2013 15:14:04.657'!
task
	^ task! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/19/2013 15:14:22.419'!
task: aTask
	task := aTask! !

!I2SUserCodeRunner methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/19/2013 16:11:22.76'!
value
	^ task visualization node value! !

UserInterface subclass: #I2STaskUi
	instanceVariableNames: 'stack titleMenu taskDescription scrollArea levelButton hintButton resetButton solutionButton parameterDisplay codeEdit playButton stepButton chapterNameLabel levelButtonContainer chapterButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2STaskUi subclass: #I2SActiveTaskUi
	instanceVariableNames: 'task taskNumber currentChapter chapters levelButtons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SActiveTaskUi class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 18:27:22.957'!
chapterOneTasks
	^I2SChapter newWithTasks:{
		(I2SRandomSearchTask
			newWithVisualizationClass: I2SListMorph
			andSize: 20)
			addHint: 'This is an unsorted List. Click on the elements to show their value. You can only look at one element at a time, just like the computer.';
			addHint: 'The only thing you can do is check one element after the other.';
			addHint: 'You can begin left and check every element until you find the number.';
			name: 'Unsorted List'.
		(I2SRandomSearchTask
			newSortedWithVisualizationClass: I2SListMorph
			andSize: 20)
			addHint: 'This time, the list is sorted, smaller elements are to the left, larger ones to the right.';
			addHint: 'The fastest way is checking the elements in the middle first.';
			addHint: 'Remember: Elements, with smaller values than your current value are to the left of your current element, larger ones to the right.';
			name: 'Sorted List'.
		(I2SRandomSearchTask
			newSortedWithVisualizationClass: I2SHybridVisualization
			andSize: 16)
			addHint: 'This list is sorted and will split when you click an element.';
			addHint: 'Like before, it is a good idea to start in the middle of the list.';
			addHint: 'Smaller elements are to the left, larger ones to the right.';
			addHint: 'This is called a Search Tree.';
			name: 'Evolving List'.
		(I2SRandomSearchTask
			newWithVisualizationClass: I2STreeSectionMorph
			andSize: 20)
			addHint: 'This is a Search Tree like the one you created before. But like a computer, you can only see a small part of the tree. Click on the node you want to go.';
			addHint: 'Smaller numbers are to the left, larger ones to the right. You can only see one node of search tree at once, just like the computer.';
			name: 'Binary Search Tree'.
		(I2SRandomSearchTask 
			newWithVisualizationClass: I2STreeSectionMorph 
			andSize: 50)
			addHint: 'I disabled the manual navigation. Please write some code to find the value.';
			addHint: 'This tree is way too large to be searched manually, write some code on the right to let the computer do it for you.';
			addHint: 'Remember: Elements, with smaller values than your current value are to the left of your current element, larger ones to the right.';
			name: 'Bigger Tree';
			isCodingTask: true.
	}  andName: 'Chapter One - Searching'
	"maybe we should define a number of hints to show in the beginning, so lvl 1 and 2 are distinguishable"! !

!I2SActiveTaskUi class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:19:30.55'!
chapterThreeTasks
		^I2SChapter newWithTasks: {
		(I2SRotateTask
		newWithVisualizationClass: I2SBinaryTreeVisualization
		andList: (1 to: 20))
		addHint: 'Nothing to do here, yet.';
		name: 'Rotating a Tree'.		
	} andName: 'Chapter Three - Balancing'! !

!I2SActiveTaskUi class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 18:37:16.058'!
chapterTwoTasks
	^I2SChapter newWithTasks: {
		(I2SRandomAddTask
		newWithVisualizationClass: I2SBinaryTreeVisualization
		andSize: 20)
		addHint: 'Just click the right position.';
		name: 'Adding a value'.
		(I2SRandomAddTask
		newWithVisualizationClass: I2STreeSectionMorph
		andSize: 50)
		addHint: 'Navigate as always and click empty circles to choose a position.';
		addHint: 'New messages: self hasLeftChild, self hasRightChild, 
			self insertAsLeftChild: aValue, self insertAsRightChild: aValue';
		name: 'Adding a value'.
		
	} andName: 'Chapter Two - Adding'! !

!I2SActiveTaskUi class methodsFor: 'auto-generated' stamp: 'benjamin.siegmund 6/26/2013 16:49:55.58'!
logo
^(Form
	extent: 600@94
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1426063360 3355443200 788529152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2919235584 4278190080 4244635648 3607101440 1006632960 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 301989888 1459617792 2566914048 2147483648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3640655872 4261412864 4261412864 4278190080 4278190080 4009754624 3405774848 3036676096 2617245696 2164260864 1946157056 1761607680 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1744830464 1828716544 2550136832 3271557120 3942645760 4278190080 4278190080 4278190080 3221225472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 218103808 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 3103784960 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 402653184 1207959552 1526726656 1795162112 2080374784 2315255808 2382364672 2365587456 2113929216 1895825408 1694498816 1509949440 1056964608 536870912 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2164260864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3019898880 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 838860800 1694498816 2516582400 3154116608 3674210304 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4060086272 3758096384 3355443200 2936012800 2533359616 1996488704 1392508928 838860800 268435456 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2952790016 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 150994944 503316480 1694498816 3321888768 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3774873600 2986344448 2063597568 1124073472 603979776 402653184 218103808 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 536870912 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2868903936 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 771751936 2952790016 4009754624 4211081216 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4244635648 4143972352 4043309056 3959422976 3640655872 2751463424 1929379840 150994944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1275068416 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2785017856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 520093696 2231369728 3741319168 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 3992977408 3422552064 2902458368 2382364672 1946157056 1778384896 1610612736 1476395008 1426063360 1526726656 1627389952 1946157056 2281701376 2768240640 3355443200 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 1392508928 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2617245696 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4261412864 2483027968 1291845632 721420288 385875968 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 201326592 251658240 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 771751936 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 301989888 704643072 1157627904 1795162112 2835349504 4127195136 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2701131776 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 402653184 2684354560 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4244635648 3959422976 3372220416 1828716544 335544320 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 268435456 1761607680 3539992576 4026531840 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 922746880 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4093640704 4278190080 4278190080 4261412864 4261412864 4278190080 2969567232 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1862270976 4009754624 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 2617245696 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 3238002688 4177526784 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4211081216 2248146944 570425344 150994944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 956301312 3355443200 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 520093696 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 469762048 4278190080 4261412864 4278190080 4261412864 4278190080 1258291200 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 134217728 2483027968 4278190080 4261412864 4278190080 4278190080 4278190080 2516582400 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 2248146944 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 3187671040 1426063360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 905969664 2969567232 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1644167168 4278190080 4278190080 4261412864 4211081216 989855744 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1946157056 4278190080 4261412864 4278190080 4278190080 2231369728 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4227858432 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4244635648 3472883712 402653184 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 956301312 4076863488 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2533359616 4278190080 4261412864 4278190080 1308622848 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2684354560 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2986344448 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3254779904 654311424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 2550136832 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3825205248 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2902458368 4278190080 4278190080 1845493760 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 3909091328 4261412864 4278190080 1308622848 0 0 0 0 0 0 0 0 0 0 0 0 0 0 553648128 3791650816 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4026531840 1778384896 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1744830464 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3103784960 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3204448256 4278190080 3690987520 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2214592512 4278190080 4261412864 939524096 0 0 0 0 0 0 0 0 0 0 0 0 0 889192448 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3556769792 83886080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1056964608 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2382364672 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3003121664 4278190080 201326592 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4227858432 536870912 0 0 0 0 0 0 0 0 0 0 0 0 1744830464 4244635648 4261412864 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1828716544 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1509949440 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 1627389952 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2248146944 3305111552 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3120562176 4244635648 67108864 0 0 0 0 0 0 0 0 0 0 0 1677721600 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4194304000 1543503872 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2013265920 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 905969664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 268435456 251658240 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1929379840 3070230528 0 0 0 0 0 0 0 0 0 0 0 1694498816 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4160749568 603979776 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 3674210304 4278190080 4278190080 4278190080 4278190080 4211081216 654311424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 402653184 838860800 855638016 855638016 603979776 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1056964608 4261412864 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4093640704 637534208 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 4211081216 4261412864 4278190080 4278190080 4160749568 385875968 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3623878656 184549376 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 3690987520 1862270976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 184549376 3456106496 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1392508928 2667577344 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1375731712 150994944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1006632960 2818572288 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 704643072 2097152000 3087007744 3607101440 3992977408 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4244635648 3942645760 3506438144 3003121664 1711276032 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 637534208 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 855638016 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2063597568 4278190080 4261412864 4261412864 4093640704 134217728 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1023410176 4278190080 2449473536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 3909091328 4261412864 469762048 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3271557120 4009754624 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 671088640 3959422976 3909091328 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3875536896 4127195136 4278190080 3539992576 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 2818572288 3238002688 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3187671040 3204448256 3087007744 2801795072 2483027968 1979711488 1308622848 905969664 486539264 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 1979711488 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2080374784 3992977408 4278190080 385875968 0 0 0 0 0 0 0 0 0 369098752 3858759680 3909091328 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3892314112 3976200192 4278190080 3992977408 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 771751936 2248146944 4127195136 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 2868903936 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3774873600 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 956301312 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 4278190080 4278190080 4278190080 3976200192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3607101440 4278190080 3875536896 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 4127195136 4278190080 4076863488 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 989855744 4278190080 4261412864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1140850688 3925868544 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3187671040 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 603979776 2969567232 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4211081216 4177526784 2734686208 603979776 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 2281701376 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3992977408 218103808 0 0 0 0 0 0 0 0 0 0 637534208 3623878656 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3657433088 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 989855744 3942645760 4244635648 4278190080 4278190080 4261412864 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2147483648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3003121664 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2516582400 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2113929216 4278190080 4278190080 3036676096 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 402653184 4177526784 4261412864 4261412864 654311424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 4278190080 4261412864 4278190080 1795162112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 335544320 4261412864 4278190080 4278190080 234881024 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 704643072 1946157056 3976200192 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2768240640 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 620756992 3204448256 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 4278190080 4278190080 3539992576 1845493760 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 1342177280 2885681152 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3875536896 67108864 0 0 0 0 0 0 0 0 0 0 0 0 536870912 1644167168 3690987520 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3338665984 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 989855744 3472883712 4278190080 4278190080 4261412864 4278190080 4278190080 4026531840 2248146944 1358954496 872415232 754974720 771751936 1157627904 1879048192 3556769792 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1493172224 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 973078528 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3355443200 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 335544320 4194304000 4278190080 2046820352 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1392508928 4278190080 4278190080 4278190080 2818572288 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 486539264 4278190080 4278190080 4278190080 4278190080 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2550136832 4261412864 4278190080 4278190080 922746880 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2432696320 4244635648 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4160749568 3909091328 3925868544 3925868544 3925868544 3925868544 3925868544 3925868544 3925868544 3925868544 3992977408 4060086272 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1929379840 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2684354560 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3942645760 3204448256 2113929216 1493172224 1056964608 687865856 939524096 1577058304 2717908992 3674210304 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4026531840 838860800 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 3204448256 4261412864 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 3539992576 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4194304000 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3892314112 3925868544 3925868544 3925868544 3925868544 3925868544 3925868544 3925868544 3909091328 3992977408 4043309056 4227858432 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2852126720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 2013265920 4278190080 4261412864 4278190080 4261412864 4278190080 3976200192 1828716544 0 0 0 0 0 0 0 0 0 1258291200 3976200192 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 838860800 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 603979776 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 3825205248 4278190080 1056964608 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3640655872 4278190080 4278190080 4278190080 4278190080 234881024 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1224736768 4278190080 4278190080 4278190080 4278190080 3254779904 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 738197504 4278190080 4261412864 4278190080 4278190080 1593835520 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3204448256 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3053453312 0 134217728 134217728 134217728 134217728 134217728 134217728 134217728 134217728 150994944 167772160 201326592 989855744 2818572288 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 1023410176 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3187671040 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 419430400 0 0 0 0 0 0 0 0 50331648 402653184 3355443200 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4261412864 2432696320 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2600468480 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3992977408 318767104 553648128 553648128 553648128 553648128 553648128 553648128 553648128 536870912 838860800 805306368 1560281088 2617245696 4211081216 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2415919104 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2332033024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4110417920 0 134217728 134217728 134217728 134217728 134217728 134217728 134217728 134217728 150994944 167772160 201326592 721420288 2499805184 4261412864 4278190080 4261412864 4278190080 4278190080 4278190080 1895825408 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3422552064 4278190080 4278190080 4278190080 4261412864 4278190080 3523215360 134217728 0 0 0 0 0 0 0 0 0 0 0 0 3607101440 4278190080 4278190080 4278190080 4278190080 4278190080 201326592 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2432696320 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1912602624 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2701131776 4278190080 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 654311424 4278190080 4261412864 4278190080 4278190080 4278190080 1795162112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1946157056 4278190080 4278190080 4278190080 4261412864 4261412864 687865856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 3607101440 4278190080 4278190080 4278190080 4278190080 2214592512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1711276032 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 1912602624 4278190080 4261412864 4261412864 4278190080 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3992977408 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 1610612736 4227858432 4261412864 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2751463424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 989855744 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 855638016 2566914048 4278190080 4261412864 4278190080 4278190080 1275068416 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 754974720 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 1526726656 4160749568 4261412864 4261412864 4278190080 905969664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 3607101440 4278190080 4278190080 4278190080 4278190080 4278190080 3288334336 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4127195136 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3623878656 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1140850688 4261412864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2516582400 4278190080 4278190080 4278190080 4278190080 4261412864 3288334336 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2650800128 4278190080 4278190080 4278190080 4278190080 4278190080 3925868544 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 2868903936 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1224736768 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1426063360 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2264924160 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 754974720 4143972352 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2046820352 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 469762048 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1677721600 4278190080 4278190080 4278190080 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 285212672 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 536870912 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3137339392 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 285212672 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 469762048 4278190080 4261412864 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3288334336 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1426063360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2952790016 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3623878656 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 201326592 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3372220416 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1526726656 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3506438144 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2868903936 4278190080 2550136832 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1275068416 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 570425344 4244635648 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1342177280 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2600468480 4278190080 3791650816 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2030043136 4278190080 3472883712 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2214592512 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 1644167168 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2667577344 4278190080 4278190080 3288334336 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 503316480 4211081216 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3573547008 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 436207616 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2650800128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4093640704 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2147483648 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4127195136 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1342177280 4278190080 1342177280 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 889192448 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1124073472 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3841982464 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 603979776 4211081216 2902458368 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 771751936 4278190080 2315255808 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 4177526784 4261412864 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 4278190080 4278190080 2667577344 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2415919104 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 1090519040 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2768240640 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4076863488 150994944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2181038080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4194304000 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 738197504 4278190080 704643072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2566914048 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1426063360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 251658240 4093640704 1996488704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 4278190080 1174405120 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2415919104 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2801795072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2281701376 4278190080 2063597568 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 150994944 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4227858432 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 184549376 4211081216 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4261412864 788529152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 285212672 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4009754624 184549376 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2986344448 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 251658240 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 150994944 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4127195136 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 4177526784 1224736768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 687865856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 4143972352 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2030043136 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 704643072 4244635648 1526726656 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1962934272 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1912602624 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1040187392 4261412864 4278190080 4278190080 4244635648 3858759680 4278190080 4278190080 4278190080 4278190080 2751463424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 637534208 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1946157056 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 419430400 4194304000 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 486539264 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1795162112 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 704643072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1207959552 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 520093696 4211081216 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1560281088 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 4278190080 1107296256 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3321888768 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4227858432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2617245696 4278190080 4278190080 4278190080 2818572288 2650800128 4278190080 4278190080 4278190080 4261412864 4278190080 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 973078528 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 268435456 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2600468480 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 738197504 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 285212672 4076863488 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1459617792 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 771751936 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1476395008 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 939524096 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3321888768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 687865856 1577058304 4278190080 4278190080 4278190080 4261412864 4278190080 1962934272 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1325400064 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2415919104 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 587202560 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3556769792 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 2130706432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 922746880 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1795162112 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1409286144 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2248146944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1644167168 4278190080 4261412864 4261412864 3959422976 117440512 268435456 4278190080 4261412864 4278190080 4278190080 4261412864 3355443200 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1677721600 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4194304000 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2734686208 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1224736768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1744830464 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2617245696 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 855638016 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2533359616 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3271557120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 838860800 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3355443200 4261412864 4278190080 4278190080 3372220416 0 0 3456106496 4278190080 4278190080 4278190080 4278190080 4278190080 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2147483648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2919235584 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 1509949440 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2868903936 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 603979776 4227858432 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3539992576 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 4211081216 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 4093640704 4278190080 4278190080 4278190080 1711276032 0 0 1459617792 4278190080 4278190080 4278190080 4278190080 4278190080 2466250752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2667577344 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4177526784 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2986344448 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2013265920 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 637534208 1962934272 2701131776 2868903936 2885681152 2717908992 2298478592 1325400064 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1962934272 285212672 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3909091328 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2902458368 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 4227858432 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 889192448 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 553648128 4227858432 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3305111552 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1392508928 4278190080 4278190080 4278190080 4278190080 0 0 0 385875968 4177526784 4278190080 4278190080 4278190080 4261412864 4244635648 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3170893824 4278190080 4278190080 4278190080 4261412864 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2264924160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 402653184 4227858432 4261412864 4278190080 4278190080 4261412864 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 2499805184 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 251658240 1140850688 2583691264 4143972352 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3271557120 1442840576 251658240 0 0 0 0 0 0 0 0 0 0 0 201326592 3388997632 4278190080 4278190080 4278190080 4177526784 4143972352 4143972352 4143972352 4143972352 4143972352 4143972352 4143972352 4143972352 3992977408 3707764736 3707764736 3707764736 3690987520 3959422976 4278190080 4227858432 318767104 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3204448256 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2667577344 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3355443200 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4043309056 83886080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 956301312 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2264924160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3875536896 4278190080 4278190080 4278190080 3070230528 0 0 0 100663296 3892314112 4261412864 4278190080 4278190080 4261412864 4261412864 956301312 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3674210304 4278190080 4278190080 4278190080 4278190080 3825205248 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 268435456 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 4278190080 4278190080 4278190080 4278190080 3355443200 4043309056 4278190080 4278190080 4278190080 4278190080 4278190080 2986344448 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 184549376 2969567232 4278190080 4261412864 4278190080 4278190080 4278190080 4009754624 3288334336 4026531840 3741319168 3875536896 4278190080 4278190080 4278190080 4278190080 4261412864 4227858432 1895825408 0 0 0 0 0 0 0 0 0 0 0 0 16777216 1560281088 4227858432 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 3892314112 150994944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2751463424 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 2164260864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 704643072 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1543503872 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1560281088 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1342177280 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 637534208 4278190080 4261412864 4278190080 4278190080 1560281088 0 0 0 0 2785017856 4278190080 4278190080 4278190080 4278190080 4278190080 2734686208 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4194304000 4278190080 4278190080 4278190080 4278190080 1090519040 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2550136832 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 335544320 3992977408 4278190080 4278190080 4278190080 4278190080 4278190080 3539992576 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 654311424 3120562176 4278190080 4278190080 4278190080 4076863488 1879048192 671088640 1929379840 2936012800 0 3305111552 2030043136 0 3909091328 1962934272 1811939328 4110417920 4278190080 4278190080 4278190080 3674210304 855638016 0 0 0 0 0 0 0 0 0 0 0 0 1073741824 4261412864 4278190080 4278190080 4278190080 3623878656 3103784960 2583691264 1862270976 1291845632 1023410176 889192448 889192448 1174405120 2634022912 4278190080 4261412864 3674210304 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2499805184 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1459617792 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3405774848 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1006632960 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2197815296 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 822083584 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1862270976 4278190080 4278190080 4261412864 4278190080 603979776 0 0 0 0 788529152 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 369098752 2264924160 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4093640704 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2113929216 4278190080 4261412864 4278190080 4278190080 4278190080 2399141888 117440512 3909091328 4278190080 4278190080 4278190080 4278190080 4278190080 4110417920 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 1795162112 4278190080 4278190080 4278190080 4127195136 2181038080 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 2399141888 4211081216 4278190080 4261412864 4278190080 1694498816 0 0 0 0 0 0 0 0 0 0 0 721420288 4227858432 4278190080 4278190080 4278190080 1795162112 0 0 0 0 0 0 0 0 0 1342177280 4278190080 2801795072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2432696320 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 838860800 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1275068416 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3808428032 234881024 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2801795072 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4227858432 671088640 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3506438144 4261412864 4278190080 4278190080 4026531840 0 0 0 0 0 0 3959422976 4278190080 4278190080 4278190080 4261412864 4278190080 2181038080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 553648128 4278190080 4278190080 4278190080 4278190080 4278190080 167772160 486539264 4177526784 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2550136832 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3690987520 4278190080 4278190080 4278190080 4261412864 4278190080 402653184 100663296 3825205248 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3254779904 4278190080 4278190080 4278190080 4093640704 385875968 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 385875968 4043309056 4261412864 4261412864 4278190080 2617245696 0 0 0 0 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 3321888768 1593835520 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2650800128 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3238002688 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3976200192 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3271557120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4194304000 553648128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 486539264 4278190080 4278190080 4278190080 4278190080 1946157056 0 0 0 0 0 0 2717908992 4261412864 4278190080 4278190080 4278190080 4261412864 3590324224 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1241513984 4278190080 4278190080 4278190080 4278190080 4227858432 0 0 3053453312 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 2147483648 0 33554432 3690987520 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 3422552064 4278190080 4261412864 4261412864 3590324224 167772160 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 335544320 3758096384 4278190080 4261412864 4278190080 2264924160 0 0 0 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 2818572288 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2868903936 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2701131776 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4227858432 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3422552064 150994944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3640655872 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4160749568 452984832 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2701131776 4278190080 4278190080 4278190080 4278190080 100663296 0 0 0 0 0 0 1509949440 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 335544320 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1929379840 4278190080 4278190080 4278190080 4278190080 3489660928 0 0 167772160 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1996488704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4060086272 4278190080 4278190080 4278190080 4261412864 4060086272 167772160 0 0 3472883712 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1006632960 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2499805184 4278190080 4278190080 4278190080 4211081216 369098752 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 369098752 4076863488 4278190080 4261412864 4278190080 1644167168 0 0 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 905969664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3204448256 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 285212672 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1677721600 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3825205248 268435456 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3976200192 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4160749568 419430400 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 3841982464 4261412864 4278190080 4261412864 3556769792 16777216 0 0 0 0 0 0 385875968 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 2885681152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2617245696 4278190080 4278190080 4278190080 4278190080 2600468480 0 0 0 2969567232 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1107296256 4278190080 4261412864 4278190080 4278190080 4278190080 2533359616 0 0 0 2785017856 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1627389952 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1459617792 4278190080 4278190080 4278190080 4278190080 822083584 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 570425344 4278190080 4278190080 4261412864 4278190080 218103808 0 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3841982464 4278190080 4278190080 4278190080 4278190080 4261412864 3405774848 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2667577344 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4110417920 687865856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4110417920 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4160749568 419430400 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 620756992 4278190080 4278190080 4278190080 4278190080 2499805184 0 0 0 0 0 0 0 0 3657433088 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 285212672 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3288334336 4278190080 4278190080 4278190080 4278190080 1711276032 0 0 0 1124073472 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2466250752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3137339392 4261412864 4278190080 4278190080 4261412864 4160749568 0 0 0 0 2063597568 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2248146944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 150994944 788529152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3640655872 4261412864 4278190080 4278190080 3355443200 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 2583691264 4278190080 4261412864 4278190080 3607101440 33554432 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 939524096 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1006632960 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3456106496 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4160749568 1442840576 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4227858432 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4160749568 452984832 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2818572288 4278190080 4278190080 4261412864 4278190080 771751936 0 0 0 0 0 0 0 0 1593835520 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1509949440 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3623878656 4261412864 4278190080 4278190080 4278190080 805306368 0 0 0 0 3741319168 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3942645760 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 620756992 4278190080 4278190080 4278190080 4261412864 4278190080 1996488704 0 0 0 0 1291845632 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2868903936 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 352321536 2634022912 4278190080 3321888768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 973078528 4278190080 4278190080 4278190080 4278190080 385875968 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 50331648 4278190080 4278190080 4278190080 4278190080 1107296256 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1694498816 4278190080 4278190080 4278190080 4261412864 4278190080 2801795072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 587202560 2785017856 4076863488 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 285212672 2063597568 4278190080 4244635648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 150994944 3892314112 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1493172224 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4177526784 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4177526784 520093696 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 4278190080 4278190080 4278190080 4278190080 3875536896 0 0 0 0 0 0 0 0 0 268435456 4194304000 4278190080 4278190080 4278190080 4278190080 4261412864 3305111552 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 3774873600 4278190080 4278190080 4278190080 4278190080 50331648 0 0 0 0 905969664 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2164260864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3187671040 4278190080 4278190080 4278190080 4261412864 4278190080 218103808 0 0 0 0 469762048 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3338665984 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3087007744 117440512 268435456 268435456 268435456 268435456 268435456 268435456 268435456 268435456 268435456 268435456 268435456 268435456 352321536 1811939328 3774873600 4194304000 4278190080 4278190080 2650800128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3758096384 4278190080 4278190080 4261412864 3103784960 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 1694498816 4278190080 4278190080 4278190080 4060086272 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3640655872 4278190080 4278190080 4278190080 4261412864 4278190080 285212672 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3942645760 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1711276032 3674210304 4211081216 4278190080 3690987520 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4110417920 33554432 268435456 268435456 268435456 268435456 268435456 268435456 268435456 268435456 268435456 268435456 268435456 268435456 301989888 1459617792 3573547008 4127195136 4278190080 4278190080 3590324224 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 218103808 4093640704 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2684354560 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3976200192 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4211081216 637534208 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1560281088 4278190080 4278190080 4278190080 4278190080 2046820352 0 0 0 0 0 0 0 0 0 83886080 3741319168 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 486539264 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 3909091328 4278190080 4278190080 4278190080 4076863488 16777216 0 0 0 0 134217728 3976200192 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 251658240 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 150994944 4093640704 4261412864 4278190080 4278190080 4278190080 2130706432 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3539992576 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 2063597568 0 0 0 0 0 0 0 0 0 0 0 0 0 0 402653184 4278190080 4261412864 4278190080 4278190080 1610612736 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 352321536 4143972352 4261412864 4261412864 4278190080 1409286144 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 436207616 4177526784 4261412864 4278190080 4261412864 4278190080 1291845632 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4227858432 3657433088 3690987520 3690987520 3690987520 3690987520 3690987520 3690987520 3690987520 3690987520 3690987520 3690987520 3690987520 3690987520 3707764736 4278190080 4278190080 4278190080 4278190080 4278190080 3288334336 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 3036676096 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 587202560 4177526784 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3288334336 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3791650816 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4244635648 754974720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 536870912 1207959552 1174405120 1174405120 1174405120 1040187392 889192448 889192448 889192448 905969664 637534208 620756992 620756992 620756992 570425344 335544320 318767104 301989888 285212672 268435456 251658240 234881024 201326592 184549376 150994944 134217728 100663296 83886080 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2969567232 4261412864 4278190080 4261412864 4244635648 788529152 0 0 0 0 0 0 0 0 0 0 2852126720 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2768240640 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4060086272 4278190080 4278190080 4278190080 3758096384 0 0 0 0 0 0 2030043136 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1744830464 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2164260864 4278190080 4278190080 4278190080 4261412864 4009754624 50331648 0 0 0 0 0 0 3992977408 4278190080 4278190080 4278190080 4278190080 4278190080 3741319168 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1459617792 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1040187392 4261412864 4278190080 4261412864 4278190080 587202560 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 3640655872 4278190080 4278190080 4261412864 2952790016 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3087007744 4278190080 4278190080 4261412864 4278190080 2852126720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2885681152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2449473536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 3976200192 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4026531840 285212672 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3607101440 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1090519040 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 872415232 4160749568 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4227858432 4177526784 4143972352 4110417920 4043309056 3976200192 3942645760 3875536896 3808428032 3875536896 2483027968 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4261412864 4194304000 50331648 0 0 0 0 0 0 0 0 0 0 956301312 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3892314112 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 318767104 4211081216 4278190080 4278190080 4278190080 3456106496 0 0 0 0 0 0 0 4060086272 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4076863488 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 4278190080 4278190080 4278190080 4278190080 4278190080 2600468480 0 0 0 0 0 0 0 3405774848 4278190080 4278190080 4278190080 4278190080 4278190080 3942645760 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 889192448 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1862270976 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 1593835520 4278190080 4278190080 4278190080 4143972352 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1929379840 4278190080 4261412864 4278190080 4278190080 3741319168 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 2315255808 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1660944384 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 285212672 3909091328 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4093640704 721420288 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3338665984 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1811939328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1627389952 2936012800 3959422976 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 4278190080 4026531840 2952790016 1761607680 620756992 0 0 0 0 0 0 0 0 0 0 0 0 0 2046820352 4278190080 4278190080 4278190080 4278190080 2566914048 0 0 0 0 0 0 0 0 0 0 0 0 4143972352 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 889192448 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 520093696 4278190080 4278190080 4278190080 4261412864 3154116608 0 0 0 0 0 0 0 2214592512 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2046820352 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1761607680 4278190080 4278190080 4278190080 4278190080 4278190080 50331648 0 0 0 0 0 0 0 2835349504 4278190080 4278190080 4278190080 4278190080 4278190080 4160749568 150994944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4160749568 3288334336 3321888768 3321888768 3321888768 3321888768 3321888768 3489660928 3590324224 3774873600 3909091328 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4211081216 637534208 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2717908992 4278190080 4278190080 4278190080 3456106496 0 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 16777216 4278190080 4278190080 4278190080 4278190080 838860800 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 989855744 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1677721600 4278190080 4261412864 4278190080 4261412864 4211081216 503316480 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4227858432 4227858432 4227858432 4227858432 4227858432 4227858432 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1778384896 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3321888768 3321888768 3321888768 3321888768 3321888768 3321888768 3456106496 3590324224 3741319168 3875536896 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 1056964608 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 3858759680 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1308622848 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2768240640 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2801795072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 3674210304 4244635648 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4160749568 1728053248 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 3909091328 4261412864 4278190080 4278190080 4278190080 218103808 0 0 0 0 0 0 0 0 0 0 0 0 2650800128 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 3556769792 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1207959552 4278190080 4278190080 4278190080 4278190080 2768240640 0 0 0 0 0 0 0 553648128 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3791650816 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3607101440 4278190080 4278190080 4278190080 4278190080 2113929216 0 0 0 0 0 0 0 0 2281701376 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 201326592 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 536870912 1560281088 3087007744 4194304000 4278190080 4261412864 4278190080 4160749568 402653184 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3456106496 4278190080 4278190080 4278190080 2650800128 0 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 0 3758096384 4278190080 4278190080 4278190080 2533359616 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1962934272 150994944 150994944 150994944 150994944 150994944 150994944 150994944 150994944 117440512 2197815296 3959422976 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 352321536 0 0 0 0 0 0 0 0 0 0 0 67108864 637534208 3523215360 4278190080 4261412864 4278190080 4261412864 4278190080 805306368 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 335544320 738197504 1526726656 2449473536 3372220416 4076863488 4211081216 4278190080 4261412864 4278190080 4278190080 1291845632 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 369098752 1375731712 2751463424 4110417920 4278190080 4261412864 4278190080 4244635648 788529152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3690987520 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1778384896 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2164260864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3841982464 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 721420288 3271557120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2197815296 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 436207616 4194304000 4278190080 4278190080 4261412864 3539992576 0 0 0 0 0 0 0 0 0 0 0 0 0 1342177280 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 754974720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1996488704 4278190080 4278190080 4278190080 4278190080 2080374784 0 0 0 0 0 0 0 0 2768240640 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1241513984 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1258291200 4278190080 4278190080 4278190080 4261412864 4278190080 402653184 0 0 0 0 0 0 0 0 1778384896 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 855638016 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 3355443200 4278190080 4278190080 4127195136 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3942645760 4278190080 4278190080 4278190080 2315255808 0 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 0 3103784960 4278190080 4278190080 4278190080 3640655872 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 4261412864 4244635648 4244635648 4244635648 4244635648 4244635648 4244635648 4244635648 4244635648 4261412864 4278190080 3338665984 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3690987520 3372220416 2936012800 2399141888 2080374784 1895825408 1744830464 1577058304 1577058304 1744830464 2399141888 3288334336 3791650816 4278190080 4278190080 4261412864 4278190080 4261412864 4278190080 1476395008 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 553648128 3690987520 4278190080 4278190080 4278190080 838860800 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 2449473536 4278190080 4278190080 4211081216 520093696 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 150994944 3556769792 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1912602624 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1526726656 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3187671040 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3070230528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1996488704 4278190080 4278190080 4278190080 4278190080 2298478592 0 0 0 0 0 0 0 0 0 0 0 0 0 369098752 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 2332033024 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2751463424 4278190080 4278190080 4278190080 4278190080 1426063360 0 0 0 0 0 0 0 0 285212672 4194304000 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4076863488 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 3674210304 4278190080 4278190080 4278190080 4278190080 2600468480 0 0 0 0 0 0 0 0 0 1392508928 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1644167168 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 251658240 4177526784 4278190080 4076863488 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 2248146944 0 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 0 2650800128 4278190080 4278190080 4261412864 4076863488 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 4194304000 4127195136 4127195136 4127195136 4127195136 4127195136 4227858432 4278190080 4278190080 4261412864 4261412864 2885681152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4261412864 4194304000 1426063360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4143972352 4278190080 4278190080 402653184 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 3942645760 4261412864 4194304000 268435456 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 134217728 3489660928 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1493172224 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1073741824 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1258291200 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 788529152 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 855638016 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4211081216 4278190080 4278190080 4278190080 4278190080 2583691264 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 2030043136 1929379840 4227858432 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4009754624 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3539992576 4278190080 4278190080 4278190080 4278190080 771751936 0 0 0 0 0 0 0 0 0 3456106496 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1409286144 0 0 0 0 0 0 0 0 0 0 0 0 0 0 419430400 4227858432 4278190080 4278190080 4261412864 4160749568 0 0 0 0 0 0 0 0 0 0 1023410176 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2399141888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 3741319168 4278190080 3523215360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4261412864 4278190080 4278190080 2499805184 0 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 0 2365587456 4261412864 4278190080 4278190080 4093640704 134217728 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1862270976 0 0 0 0 0 0 100663296 1895825408 4278190080 4278190080 2415919104 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2986344448 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3187671040 4278190080 4177526784 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3405774848 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 704643072 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2600468480 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1191182336 4278190080 4261412864 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1660944384 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4261412864 4278190080 117440512 0 0 0 0 0 0 0 0 0 788529152 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3422552064 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2768240640 4278190080 4278190080 4278190080 4278190080 2818572288 0 0 0 0 0 0 0 0 0 0 654311424 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3187671040 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2214592512 4278190080 2684354560 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 3120562176 0 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 0 2231369728 4278190080 4278190080 4278190080 4110417920 201326592 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 536870912 4211081216 1728053248 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3439329280 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1577058304 4278190080 4026531840 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1140850688 4278190080 3825205248 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 3238002688 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4076863488 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 301989888 4211081216 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3456106496 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4060086272 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4060086272 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2751463424 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3825205248 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 4278190080 4261412864 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 3221225472 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1073741824 0 0 0 0 0 0 0 0 0 0 0 0 402653184 4278190080 4261412864 4278190080 4278190080 4278190080 520093696 0 0 0 0 0 0 0 0 0 0 285212672 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3976200192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 184549376 4278190080 1895825408 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 3992977408 0 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 0 2315255808 4261412864 4278190080 4278190080 4093640704 150994944 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 3372220416 1224736768 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4227858432 4143972352 4160749568 4244635648 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2483027968 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 4278190080 3221225472 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4060086272 3036676096 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3355443200 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3724541952 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3992977408 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3942645760 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 4278190080 4278190080 4278190080 4261412864 4211081216 469762048 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 520093696 4278190080 4278190080 4278190080 4278190080 3825205248 0 0 0 0 0 0 0 0 0 0 0 1207959552 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3758096384 33554432 0 0 0 0 0 0 0 0 0 0 0 2264924160 4278190080 4261412864 4278190080 4278190080 2684354560 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1291845632 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4278190080 167772160 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 0 2516582400 4278190080 4278190080 4261412864 4076863488 50331648 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 2533359616 721420288 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 33554432 67108864 67108864 67108864 67108864 184549376 1224736768 2969567232 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1073741824 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1509949440 2164260864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 838860800 1023410176 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3221225472 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1895825408 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2466250752 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1946157056 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1124073472 4278190080 4278190080 4278190080 4261412864 4043309056 1291845632 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1308622848 1124073472 4093640704 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2801795072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 956301312 4278190080 4278190080 4278190080 4278190080 3221225472 0 0 0 0 0 0 0 0 0 0 0 0 3976200192 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4244635648 671088640 0 0 0 0 0 0 0 0 0 0 0 3925868544 4261412864 4278190080 4261412864 4211081216 637534208 0 0 0 0 0 0 0 0 0 0 0 0 3959422976 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 318767104 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3355443200 4278190080 4278190080 4278190080 4278190080 922746880 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 0 2936012800 4278190080 4278190080 4278190080 3707764736 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 352321536 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 134217728 1325400064 3808428032 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4160749568 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 134217728 3338665984 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4211081216 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 654311424 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4143972352 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3690987520 4278190080 4278190080 4278190080 4278190080 2013265920 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2214592512 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 469762048 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1409286144 4278190080 4278190080 4278190080 4278190080 2617245696 0 0 0 0 0 0 0 0 0 0 0 0 1258291200 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3271557120 0 0 0 0 0 0 0 0 0 0 1526726656 4278190080 4278190080 4278190080 4278190080 3590324224 0 0 0 0 0 0 0 0 0 0 0 0 0 3170893824 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 738197504 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2046820352 4278190080 4278190080 4278190080 4278190080 1895825408 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 0 3556769792 4278190080 4278190080 4278190080 2499805184 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 2264924160 4160749568 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3254779904 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 3741319168 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2885681152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3976200192 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 855638016 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 503316480 4194304000 4261412864 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 788529152 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2466250752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1862270976 4278190080 4278190080 4278190080 4278190080 2013265920 0 0 0 0 0 0 0 0 0 0 0 0 33554432 3724541952 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 922746880 0 0 0 0 0 0 0 0 50331648 3925868544 4278190080 4278190080 4278190080 4278190080 486539264 0 0 0 0 0 0 0 0 0 0 0 0 0 2382364672 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1191182336 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 754974720 4261412864 4261412864 4278190080 4261412864 3388997632 0 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 553648128 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 301989888 3959422976 4261412864 4261412864 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2315255808 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 4244635648 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4060086272 251658240 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3103784960 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2667577344 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1694498816 4278190080 4278190080 4278190080 4261412864 2885681152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4060086272 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4026531840 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2365587456 4261412864 4278190080 4278190080 4278190080 1358954496 0 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2868903936 0 0 0 0 0 0 0 0 771751936 4244635648 4278190080 4278190080 4261412864 3187671040 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1593835520 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1644167168 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3590324224 4278190080 4278190080 4278190080 4278190080 486539264 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 1325400064 4278190080 4278190080 4261412864 3808428032 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 285212672 3271557120 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 822083584 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1056964608 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1342177280 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1811939328 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 234881024 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3858759680 4278190080 4278190080 4261412864 4278190080 1426063360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1962934272 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1929379840 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2852126720 4278190080 4278190080 4278190080 4261412864 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 117440512 0 0 0 0 0 0 0 3019898880 4278190080 4278190080 4261412864 4278190080 1258291200 0 0 0 0 0 0 0 0 0 0 0 0 0 0 805306368 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 2181038080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 469762048 4278190080 4261412864 4278190080 4278190080 3204448256 0 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 0 3556769792 4278190080 4261412864 4278190080 2365587456 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 3623878656 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4227858432 251658240 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2164260864 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3372220416 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2919235584 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1006632960 4278190080 4261412864 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4026531840 134217728 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3355443200 4278190080 4278190080 4278190080 4244635648 822083584 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1426063360 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3120562176 0 0 0 0 0 0 654311424 4278190080 4278190080 4278190080 4278190080 3674210304 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 184549376 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2801795072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2583691264 4278190080 4261412864 4261412864 4211081216 402653184 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 452984832 4177526784 4261412864 4278190080 4278190080 184549376 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 3456106496 4261412864 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3154116608 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 3590324224 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2650800128 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4110417920 134217728 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2852126720 4278190080 4278190080 4278190080 4278190080 2550136832 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3137339392 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 1157627904 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3841982464 4278190080 4278190080 4278190080 4227858432 671088640 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 4160749568 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4194304000 369098752 0 0 0 0 0 2684354560 4278190080 4278190080 4278190080 4261412864 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 134217728 4160749568 4278190080 4278190080 4278190080 4278190080 4278190080 3388997632 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 3573547008 4278190080 4278190080 4278190080 3456106496 0 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 0 2533359616 4278190080 4278190080 4278190080 1761607680 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 318767104 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2281701376 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 805306368 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 536870912 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 654311424 4244635648 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2936012800 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3925868544 4278190080 4278190080 4278190080 4278190080 486539264 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1476395008 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 3741319168 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4194304000 520093696 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1711276032 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2013265920 0 0 0 0 0 4110417920 4278190080 4278190080 4278190080 3858759680 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4009754624 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 419430400 4093640704 4278190080 4261412864 4278190080 1946157056 0 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 855638016 4278190080 4261412864 4278190080 3758096384 83886080 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 469762048 4177526784 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 637534208 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2650800128 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 838860800 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 4076863488 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 855638016 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1275068416 4278190080 4278190080 4278190080 4261412864 3875536896 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4194304000 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1426063360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 268435456 4278190080 4278190080 4278190080 4278190080 4177526784 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3774873600 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 83886080 0 0 0 2315255808 4278190080 4278190080 4278190080 4278190080 1560281088 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 3875536896 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 603979776 4278190080 4261412864 4261412864 4278190080 1140850688 0 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 0 0 3825205248 4278190080 4261412864 4177526784 218103808 0 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1879048192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1728053248 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4177526784 402653184 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 922746880 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1694498816 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3422552064 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3741319168 4278190080 4278190080 4278190080 4278190080 2785017856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1962934272 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3372220416 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1090519040 4278190080 4278190080 4278190080 4278190080 4160749568 234881024 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2113929216 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2147483648 0 0 218103808 4244635648 4261412864 4278190080 4261412864 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 3741319168 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 620756992 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1006632960 4194304000 4278190080 4261412864 4278190080 1056964608 0 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 0 67108864 3506438144 4278190080 4278190080 4278190080 1040187392 0 0 0 0 0 0 0 0 704643072 4227858432 4278190080 4278190080 4278190080 1912602624 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2902458368 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4261412864 3254779904 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4127195136 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 654311424 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3707764736 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2214592512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 704643072 4261412864 4278190080 4278190080 4278190080 4278190080 520093696 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 503316480 4177526784 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 536870912 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1946157056 4278190080 4278190080 4278190080 4278190080 4143972352 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4127195136 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3741319168 0 0 1610612736 4278190080 4278190080 4261412864 4278190080 1761607680 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 3590324224 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1728053248 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 335544320 3959422976 4278190080 4261412864 4278190080 1577058304 0 0 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 0 117440512 3707764736 4278190080 4278190080 4127195136 637534208 0 0 0 0 0 0 0 0 0 738197504 4227858432 4278190080 4278190080 4261412864 2499805184 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2667577344 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3909091328 486539264 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2902458368 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 251658240 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1811939328 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4194304000 268435456 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2080374784 4261412864 4278190080 4278190080 4278190080 3640655872 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3741319168 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3707764736 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2751463424 4278190080 4278190080 4278190080 4261412864 4127195136 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1258291200 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1526726656 0 4143972352 4278190080 4278190080 4278190080 4278190080 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 3456106496 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2818572288 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 218103808 2902458368 4278190080 4261412864 4278190080 3321888768 184549376 0 1811939328 3003121664 0 3321888768 2097152000 67108864 3942645760 1426063360 0 0 0 1895825408 4093640704 4278190080 4278190080 3758096384 419430400 0 0 0 0 0 0 0 0 0 0 788529152 4244635648 4278190080 4278190080 4278190080 4043309056 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 771751936 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 989855744 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 385875968 4261412864 637534208 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2046820352 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4127195136 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3892314112 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4043309056 4278190080 4278190080 4278190080 4278190080 2231369728 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1291845632 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 838860800 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3640655872 4278190080 4278190080 4278190080 4278190080 4060086272 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 3925868544 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4194304000 2197815296 4278190080 4261412864 4278190080 4278190080 1744830464 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3321888768 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3657433088 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1660944384 3892314112 4278190080 4278190080 4278190080 2231369728 2399141888 2936012800 0 3288334336 2030043136 0 3925868544 1426063360 654311424 1728053248 3724541952 4278190080 4278190080 4244635648 2600468480 0 0 0 0 0 0 0 0 0 0 0 0 1627389952 4278190080 4278190080 4278190080 4278190080 4278190080 2902458368 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2650800128 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 721420288 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 671088640 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1946157056 4278190080 4278190080 4278190080 4278190080 4278190080 2147483648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 989855744 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2667577344 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 1476395008 4278190080 4261412864 4278190080 4261412864 4278190080 1073741824 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3875536896 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3070230528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 3925868544 4261412864 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1107296256 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 3976200192 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3254779904 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3875536896 134217728 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2147483648 4211081216 4261412864 4278190080 4278190080 4278190080 3959422976 4043309056 3590324224 2969567232 4143972352 4278190080 4278190080 4278190080 4278190080 4211081216 3154116608 184549376 0 0 0 0 0 0 0 0 0 0 16777216 83886080 1744830464 4278190080 4278190080 4278190080 4261412864 4261412864 4261412864 4278190080 3238002688 218103808 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3758096384 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4026531840 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 0 0 0 0 0 0 0 0 0 0 0 1459617792 4278190080 889192448 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2650800128 4278190080 4278190080 4278190080 4261412864 4211081216 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 3607101440 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2264924160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 16777216 3355443200 4278190080 4278190080 4278190080 4261412864 4278190080 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2399141888 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1023410176 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4026531840 4278190080 4278190080 4278190080 4278190080 3741319168 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3053453312 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2516582400 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3170893824 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 285212672 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2030043136 2298478592 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 268435456 1325400064 3355443200 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3238002688 1476395008 486539264 0 0 0 0 0 0 0 0 0 0 0 0 872415232 2130706432 2365587456 1979711488 1493172224 1090519040 956301312 939524096 1023410176 1207959552 1862270976 2264924160 1778384896 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 889192448 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3657433088 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 452984832 3137339392 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 922746880 3221225472 0 0 0 0 0 0 0 0 0 0 0 2583691264 4278190080 1442840576 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4060086272 4278190080 4278190080 4278190080 4278190080 3472883712 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 335544320 4244635648 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1375731712 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 184549376 4143972352 4278190080 4278190080 4278190080 4278190080 2902458368 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 721420288 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3489660928 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 419430400 4143972352 4278190080 4278190080 4278190080 4278190080 3573547008 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 704643072 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3019898880 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 469762048 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1157627904 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4060086272 1325400064 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1090519040 1962934272 2415919104 2499805184 2248146944 1677721600 805306368 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 822083584 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2348810240 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3019898880 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 352321536 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2466250752 2919235584 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3187671040 2197815296 0 0 0 0 0 0 0 0 0 0 0 3707764736 4278190080 2852126720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 771751936 4261412864 4261412864 4278190080 4261412864 4278190080 553648128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1275068416 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 1979711488 4278190080 4278190080 4278190080 4278190080 4278190080 788529152 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3607101440 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 536870912 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 587202560 4244635648 4278190080 4278190080 4278190080 4278190080 3422552064 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2298478592 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 2248146944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2885681152 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1375731712 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1375731712 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1040187392 4261412864 805306368 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 956301312 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 3405774848 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3238002688 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 419430400 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 3942645760 2080374784 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 419430400 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 587202560 4244635648 1325400064 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2919235584 4278190080 4278190080 4278190080 4278190080 2013265920 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3321888768 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 1409286144 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 117440512 4194304000 4278190080 4278190080 4278190080 4278190080 4026531840 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1124073472 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3774873600 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1040187392 4278190080 4278190080 4278190080 4278190080 4278190080 3238002688 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 150994944 4060086272 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 503316480 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2734686208 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3003121664 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1711276032 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1426063360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3623878656 4261412864 385875968 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1358954496 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 486539264 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 335544320 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3154116608 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 687865856 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1577058304 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1593835520 4278190080 1308622848 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 754974720 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2197815296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2885681152 4278190080 855638016 0 0 0 0 0 0 0 0 0 0 553648128 4278190080 4261412864 4278190080 3523215360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1912602624 4278190080 4261412864 4278190080 4278190080 3271557120 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 3925868544 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1543503872 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 1795162112 4278190080 4278190080 4278190080 4278190080 4261412864 3556769792 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 234881024 4026531840 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1258291200 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1912602624 4278190080 4278190080 4278190080 4278190080 4278190080 3070230528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1342177280 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2818572288 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2583691264 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2097152000 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1241513984 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2919235584 4278190080 4244635648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2315255808 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1946157056 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 872415232 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3087007744 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 939524096 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4160749568 822083584 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 738197504 4278190080 4278190080 603979776 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1107296256 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1929379840 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2013265920 4278190080 4278190080 385875968 0 0 0 0 0 0 0 0 0 0 855638016 4278190080 4278190080 4278190080 4278190080 2164260864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1107296256 4261412864 4261412864 4278190080 4278190080 3674210304 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 738197504 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2298478592 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 4244635648 4261412864 4278190080 4278190080 4278190080 4278190080 2785017856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3288334336 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3741319168 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2969567232 4278190080 4278190080 4278190080 4278190080 4278190080 3170893824 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2835349504 4261412864 4278190080 4278190080 4278190080 4278190080 4211081216 134217728 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2634022912 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1207959552 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2986344448 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 2801795072 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3154116608 4278190080 4278190080 3607101440 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 973078528 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3808428032 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3523215360 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1711276032 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3690987520 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1409286144 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4244635648 1577058304 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 385875968 4143972352 4278190080 4278190080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1962934272 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3305111552 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2248146944 4278190080 4261412864 4278190080 0 0 0 0 0 0 0 0 0 0 0 721420288 4278190080 4278190080 4278190080 4278190080 4278190080 2483027968 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1962934272 4261412864 4278190080 4278190080 4261412864 3741319168 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1375731712 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3137339392 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 3422552064 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1979711488 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 838860800 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2734686208 0 0 0 0 0 0 0 0 0 0 0 0 0 4110417920 4278190080 4278190080 4278190080 4278190080 4278190080 3942645760 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 385875968 4278190080 4261412864 4278190080 4278190080 4278190080 3103784960 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3271557120 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3657433088 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 3707764736 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3808428032 2113929216 134217728 0 0 0 0 0 0 0 0 0 0 1191182336 3607101440 4278190080 4261412864 4278190080 2667577344 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1040187392 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2097152000 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 889192448 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2298478592 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4110417920 1426063360 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2348810240 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3271557120 1241513984 0 0 0 0 0 0 0 0 0 0 0 0 2030043136 4227858432 4278190080 4278190080 3976200192 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3187671040 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4026531840 2466250752 419430400 0 0 0 0 0 0 0 0 0 0 771751936 3288334336 4278190080 4261412864 4278190080 3808428032 0 0 0 0 0 0 0 0 0 0 0 0 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3305111552 687865856 0 0 0 0 0 0 0 0 0 0 0 0 1006632960 3305111552 4278190080 4261412864 4261412864 4278190080 3019898880 167772160 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2046820352 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4026531840 687865856 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 67108864 2986344448 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1677721600 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3808428032 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2080374784 16777216 0 0 0 0 0 0 0 0 0 0 671088640 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4227858432 1040187392 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1308622848 4278190080 4261412864 4278190080 4278190080 738197504 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 3858759680 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3271557120 16777216 0 0 0 0 0 0 0 0 0 0 0 0 520093696 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 2986344448 1358954496 620756992 419430400 318767104 352321536 436207616 637534208 1526726656 3724541952 4278190080 4261412864 4278190080 4278190080 4278190080 1728053248 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1325400064 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 603979776 4194304000 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 318767104 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2248146944 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2852126720 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3623878656 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3875536896 1627389952 603979776 268435456 33554432 0 0 0 167772160 469762048 1493172224 3976200192 4278190080 4261412864 4278190080 4278190080 3087007744 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 3338665984 1610612736 671088640 452984832 335544320 335544320 419430400 587202560 1275068416 3321888768 4278190080 4261412864 4278190080 4278190080 4278190080 2852126720 0 0 0 0 0 0 0 0 0 0 0 0 2986344448 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3087007744 922746880 436207616 100663296 0 0 0 0 100663296 452984832 1090519040 3439329280 4278190080 4278190080 4261412864 4278190080 4177526784 2365587456 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2130706432 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4261412864 2667577344 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 536870912 3892314112 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3187671040 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 3103784960 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3690987520 671088640 0 0 0 0 0 0 0 0 0 3607101440 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4227858432 2483027968 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3288334336 4278190080 4278190080 2969567232 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 587202560 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3825205248 1090519040 0 0 0 0 0 0 0 0 0 0 16777216 4043309056 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 4278190080 4278190080 4227858432 4143972352 4110417920 4127195136 4160749568 4244635648 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 771751936 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2197815296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 301989888 4177526784 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3942645760 83886080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1761607680 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4143972352 2298478592 0 0 0 0 0 0 0 0 0 0 0 0 2080374784 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4211081216 4093640704 4009754624 3875536896 3741319168 3976200192 4060086272 4177526784 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 2214592512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3372220416 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4244635648 4160749568 4127195136 4110417920 4143972352 4211081216 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 1895825408 0 0 0 0 0 0 0 0 0 0 0 0 671088640 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4160749568 4026531840 3959422976 3523215360 3489660928 3959422976 4026531840 4160749568 4278190080 4278190080 4261412864 4261412864 4278190080 3875536896 486539264 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1845493760 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3758096384 1476395008 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 251658240 1493172224 3036676096 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3036676096 1577058304 335544320 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 704643072 2717908992 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3472883712 2348810240 1426063360 855638016 67108864 805306368 1677721600 2634022912 4009754624 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4110417920 2583691264 855638016 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 4026531840 4261412864 872415232 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2936012800 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4060086272 3271557120 2449473536 1912602624 1023410176 0 0 0 0 989855744 3640655872 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 4026531840 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3657433088 0 0 0 0 0 0 0 0 0 0 0 0 0 1191182336 3925868544 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4244635648 2214592512 553648128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1056964608 3992977408 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4177526784 2701131776 1577058304 687865856 301989888 318767104 469762048 0 0 0 0 1929379840 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1342177280 0 0 0 0 0 0 0 0 0 0 0 0 0 654311424 3221225472 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 956301312 0 0 0 0 0 0 0 0 0 0 0 0 0 1426063360 4278190080 4261412864 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3607101440 1526726656 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1577058304 4261412864 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3506438144 687865856 16777216 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4143972352 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 385875968 4143972352 4261412864 4043309056 3858759680 3774873600 3724541952 3674210304 3456106496 3254779904 3154116608 3238002688 3456106496 3674210304 3707764736 3758096384 3858759680 4026531840 4278190080 3405774848 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1207959552 4278190080 4043309056 3959422976 3858759680 3774873600 3674210304 3254779904 2734686208 2365587456 2365587456 2365587456 2365587456 2399141888 2986344448 3640655872 3758096384 3825205248 3892314112 3942645760 4026531840 3690987520 2885681152 3959422976 3791650816 3674210304 3674210304 3707764736 3724541952 3724541952 3741319168 3791650816 3841982464 3892314112 3959422976 4026531840 4093640704 4160749568 4160749568 4278190080 3120562176 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1174405120 3623878656 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3925868544 3825205248 3875536896 3925868544 3976200192 4026531840 4026531840 4026531840 4026531840 4026531840 4026531840 4026531840 4026531840 4026531840 4026531840 4026531840 4026531840 4060086272 4278190080 1543503872 0 2751463424 4261412864 4244635648 4076863488 4060086272 4026531840 4009754624 3976200192 3976200192 3976200192 3942645760 3942645760 3942645760 3942645760 3942645760 3976200192 3976200192 3992977408 4026531840 4026531840 4026531840 4026531840 4060086272 4076863488 4076863488 4110417920 4110417920 4127195136 4160749568 4160749568 4160749568 4160749568 4160749568 4093640704 3456106496 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 4060086272 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 369098752 0 0 0 0 0 0 0 0 0 0 0 2751463424 4278190080 4278190080 4194304000 4060086272 3942645760 3858759680 3791650816 3724541952 3724541952 3724541952 3724541952 3724541952 3741319168 3791650816 3841982464 3892314112 3976200192 4093640704 4278190080 4127195136 1308622848 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2986344448 4177526784 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4043309056 0 973078528 2315255808 3976200192 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4211081216 536870912 0 0 0 0 0 0 0 0 0 0 0 2181038080 4076863488 4278190080 4093640704 4060086272 4026531840 4009754624 3976200192 3976200192 3976200192 3942645760 3942645760 3942645760 3942645760 3942645760 3959422976 3976200192 3992977408 4026531840 4026531840 4026531840 4026531840 4060086272 4076863488 4060086272 4110417920 4110417920 4127195136 4160749568 4160749568 4160749568 4160749568 4160749568 4127195136 3841982464 100663296 0 0 0 0 0 0 0 0 0 0 0 0 0 0 922746880 3925868544 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 4278190080 4278190080 4127195136 3573547008 1258291200 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 704643072 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4227858432 3707764736 1023410176 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3724541952 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 50331648 369098752 268435456 184549376 100663296 33554432 0 0 0 0 0 0 0 0 0 16777216 100663296 184549376 268435456 301989888 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 100663296 335544320 251658240 184549376 100663296 16777216 0 0 0 0 0 0 0 0 0 0 16777216 67108864 134217728 167772160 167772160 67108864 67108864 50331648 0 0 0 0 0 0 0 33554432 83886080 134217728 184549376 234881024 301989888 352321536 352321536 352321536 285212672 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 83886080 117440512 150994944 184549376 234881024 234881024 234881024 234881024 234881024 234881024 234881024 234881024 234881024 234881024 234881024 234881024 234881024 251658240 67108864 0 268435456 352321536 318767104 285212672 268435456 234881024 234881024 201326592 201326592 201326592 167772160 167772160 167772160 167772160 167772160 201326592 201326592 218103808 234881024 234881024 234881024 234881024 268435456 285212672 285212672 318767104 318767104 335544320 352321536 352321536 352321536 352321536 352321536 301989888 33554432 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 268435456 4093640704 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 1610612736 0 0 0 0 0 0 0 0 0 0 0 1845493760 1174405120 520093696 385875968 268435456 167772160 100663296 33554432 0 0 0 0 0 0 33554432 83886080 134217728 201326592 268435456 335544320 419430400 201326592 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 369098752 2533359616 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 3657433088 1358954496 218103808 0 671088640 1325400064 1073741824 973078528 771751936 553648128 503316480 469762048 469762048 469762048 469762048 469762048 469762048 469762048 469762048 469762048 469762048 469762048 503316480 503316480 503316480 486539264 687865856 771751936 754974720 1040187392 1040187392 1107296256 1308622848 1308622848 1308622848 1308622848 1308622848 1107296256 352321536 16777216 0 0 0 0 0 0 0 0 0 0 0 218103808 352321536 318767104 301989888 268435456 251658240 234881024 201326592 201326592 201326592 167772160 167772160 167772160 167772160 167772160 184549376 201326592 218103808 234881024 234881024 234881024 234881024 268435456 285212672 268435456 318767104 318767104 318767104 352321536 352321536 352321536 352321536 352321536 318767104 83886080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 83886080 989855744 3573547008 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 4278190080 4278190080 4278190080 4278190080 3271557120 1409286144 335544320 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 184549376 3053453312 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 3674210304 1946157056 553648128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1526726656 4160749568 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 402653184 4143972352 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 3909091328 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 50331648 1157627904 2113929216 2717908992 3036676096 3137339392 3019898880 2785017856 2181038080 1409286144 369098752 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 318767104 1191182336 1811939328 2181038080 2365587456 2298478592 2046820352 1442840576 754974720 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1962934272 4177526784 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 3724541952 1577058304 301989888 117440512 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 167772160 855638016 3841982464 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3925868544 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 754974720 4244635648 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 2902458368 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 452984832 3271557120 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4194304000 3858759680 3472883712 2382364672 1308622848 419430400 0 0 0 0 0 0 0 0 0 0 201326592 1090519040 2365587456 3523215360 3976200192 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2281701376 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2499805184 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1409286144 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1275068416 3456106496 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4127195136 3791650816 3506438144 3321888768 3254779904 3338665984 3556769792 3959422976 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3825205248 1459617792 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 956301312 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 1610612736 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1157627904 3959422976 4244635648 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4143972352 2281701376 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 889192448 4244635648 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 2617245696 67108864 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 16777216 754974720 2785017856 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4093640704 1694498816 352321536 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2013265920 3590324224 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4278190080 3825205248 1728053248 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 67108864 1811939328 3137339392 3976200192 4278190080 4278190080 4278190080 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 3690987520 2684354560 1040187392 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 285212672 2399141888 3674210304 4278190080 4278190080 4278190080 4278190080 4160749568 4060086272 3942645760 3841982464 3791650816 3791650816 3791650816 3791650816 3791650816 3791650816 3791650816 3875536896 4026531840 4143972352 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4177526784 2466250752 1358954496 419430400 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 503316480 2181038080 3607101440 4227858432 4244635648 4244635648 4261412864 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4261412864 4261412864 4244635648 4227858432 4143972352 2936012800 1392508928 50331648 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 201326592 2130706432 1644167168 1140850688 654311424 150994944 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 285212672 771751936 1275068416 1761607680 2264924160 2734686208 3238002688 3825205248 2013265920 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 117440512 469762048 788529152 1040187392 1258291200 1627389952 1912602624 2164260864 2432696320 2734686208 2986344448 3053453312 3070230528 3254779904 3254779904 3254779904 3254779904 3087007744 3019898880 2852126720 2785017856 2634022912 2533359616 2046820352 1610612736 1191182336 922746880 587202560 251658240 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!I2SActiveTaskUi class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 16:25:47.67'!
newWithTask: aTask
	| ui |
	ui := self new.
	ui task: aTask.
	^ui! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:10:49.322'!
chapters
	^chapters! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/19/2013 12:26:04.831'!
compileUserCode

	| userInput newMethod |

	userInput := self codeEdit sourceCode asString.
	self compileUserCode: userInput.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/19/2013 15:03:37.853'!
compileUserCode: userInput
	| newMethod |
	
	"Transcript showln: userInput."
	newMethod := self parameterDisplay theText, String cr, userInput.
	I2SUserCodeRunner compile:  newMethod classified: 'userMethods'.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 12:10:45.219'!
currentChapter
	^currentChapter! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 11:46:51.922'!
currentChapter: aChapter
	(currentChapter = aChapter) ifTrue: [^self].

	currentChapter := aChapter.
	
	self chapterNameLabel text: aChapter name.
	self levelButtonContainer removeAllMorphs.
	
	currentChapter tasks size to: 1 by: -1 do: [:i|
			| button |
			button := UiPushButton new text: (currentChapter tasks at: i) name.
			self connect: button signal: #clicked: toSelector: #showTask: pattern: {#=. i}.
			(i>currentChapter currentTaskNumber) ifTrue: [
				button enabled: false.
			].
			self levelButtonContainer addMorph: button.
			levelButtons add: button.
	].! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 15:54:53.755'!
initialize
	super initialize.
	self initializePanel.
	self initializeChapters.
	
	levelButtons := OrderedCollection new.
		
	"Workaround to prevent exceptions on mouseup UITextEdits"
	self taskDescription textMorph editor.
	self parameterDisplay textMorph editor.
	
	self chapters size to: 1 by: -1 do: [:i|
		| button |
		button := UiPushButton new text: (self chapters at: i) name.	
		self connect: button signal: #clicked: toSelector: #showChapter: pattern: {#=. i}.
		self titleMenu addMorph: button.		
	].
	
	self titleMenu addMorph: self class logo asMorph.
	
	self stack currentIndex: 1.
	
	self connect: self hintButton signal: #clicked: toSelector: #showHint.
	self connect: self levelButton signal: #clicked: toSelector: #showLevels.
	self connect: self chapterButton signal: #clicked: toSelector: #showChapters.
	self connect: self playButton signal: #clicked: toSelector: #runUserCode.
	self connect: self stepButton signal: #clicked: toSelector: #stepUserCode.
	self connect: self resetButton signal: #clicked: toSelector: #resetTask. 
	self connect: self codeEdit signal: #editingFinished: toSelector: #compileUserCode:! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:20:10.442'!
initializeChapters
	chapters := {
		self class chapterOneTasks.
		self class chapterTwoTasks.
		self class chapterThreeTasks.
	}! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 14:55:17.61'!
nextTask
	| oldTask |
	oldTask := self task.
	(taskNumber = self currentChapter currentTaskNumber) ifTrue: [
		| nextTask |
		taskNumber := taskNumber + 1.
		nextTask := self currentChapter nextTask.
		self currentChapter finished ifTrue: [
			self showChapterWonDialog.
		] ifFalse: [
			(levelButtonContainer submorphs at: taskNumber) enabled: true.
			self task: nextTask.
			self showTaskBeginDialog.
		].
	] ifFalse: [
		taskNumber := taskNumber+1.
		(taskNumber > self currentChapter tasks size) ifTrue: [
			self showChapterWonDialog.
		] ifFalse: [
			self task: (self currentChapter tasks at: taskNumber).
			self showTaskBeginDialog.
		]
	].

	oldTask reset.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/23/2013 16:34:07.292'!
resetTask

	self task reset. 
	self resetVisuals.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 13:03:31.221'!
resetVisualization: aVisualization
	| pos |
	
	self scrollArea transformMorph removeAllMorphs.
	self scrollArea transformMorph addMorph: aVisualization.
	pos := self scrollArea extent - aVisualization extent.
	pos := pos / 2.
	aVisualization position: (pos max: 0@0).! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 14:53:51.592'!
resetVisuals
	
	self task updateDescription.	
	self taskDescription theText: self task description.
	self showHint.
	self taskDescription textMorph editor. "Hack to update editor."
	
	self resetVisualization: task visualization.
	self playButton text: 'Play'.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 12:16:51.466'!
runUserCode
	|ucrunner|
	self compileUserCode.
	ucrunner := self task userCodeRunner.
	ucrunner isRunning ifTrue:[
		"playbutton sollte Play beinhalten"
		self playButton text: 'Play'.
	] ifFalse: [
		self playButton text: 'Stop'.
	].
 	self task userCodeRunner run.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 11:52:46.939'!
showChapter: aNumber
	(aNumber <= self chapters size) ifTrue: [
		self currentChapter: (self chapters at: aNumber).
		self stack currentIndex: 3.
		]! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 17:06:32.53'!
showChapterWonDialog
	UserDialogBoxMorph new
		title: 'You WON!!';
		label: 'This chapter is over, try the next one.';
		addSelectedCancelButton: '   YAY   ' translated
		value: nil;
		runModalIn: ActiveWorld forHand: ActiveHand at: ActiveHand position.
	self showChapters.	! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 16:20:29.542'!
showChapters
	self stack currentIndex:1.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 14:52:09.984'!
showHint
	self taskDescription append: Character cr.
	self taskDescription append: Character lf.
	self taskDescription append: self task nextHint.
	self taskDescription textMorph editor.
	
	self taskDescription scrollToShow: (50000@50000 corner: 50001@50001).! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 16:50:03.478'!
showLevels
	self stack currentIndex: 3.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 14:54:40.3'!
showTask: aNumber
	taskNumber := aNumber. 
	self task: (self currentChapter tasks at: aNumber).
	self stack currentIndex: 2.

	self showTaskBeginDialog.	! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 14:54:29.332'!
showTaskBeginDialog
	UserDialogBoxMorph new
		title: self task name;
		label: self taskDescription theText;
		addSelectedButton: '   Got it!!   ' translated
		value: nil;
		runModalIn: ActiveWorld forHand: ActiveHand at: ActiveHand position.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/22/2013 10:50:02.164'!
stepUserCode

	self task userCodeRunner step.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 16:26:27.189'!
task
	^task! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 14:42:50.46'!
task: aTask
	task ifNotNil:[
		task disconnectSignal: #visualization: from: self.
		task disconnectSignal: #completed: from: self.
	].

	task := aTask.
	self resetTask.

	self parameterDisplay theText: task userCodeSignature.
	self codeEdit sourceCode: task userCode.
	
	self
		connect: task
		signal: #visualization:
		toSelector: #resetVisualization:.
		
	self
		connect: task
		signal: #completed:
		toSelector: #taskComplete:.! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/12/2013 17:48:43.479'!
taskComplete: aBoolean
	aBoolean ifTrue:[
		UserDialogBoxMorph new
			title: 'You WON!!';
			label: 'You WON!! You needed ',(self task clickCount asString),' clicks.
Proceeding to next level';
			addSelectedCancelButton: '   YAY   ' translated
			value: nil;
			runModalIn: ActiveWorld forHand: ActiveHand at: ActiveHand position.
		self nextTask.
	].! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 11:55:23.934'!
unlockAll
	self chapters do:[ :ea|
		ea unlockAll.
	].! !

!I2SActiveTaskUi methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/19/2013 14:40:23.86'!
userCode
	^ userCode! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.592'!
chapterButton
	"No description given."
	
	^ chapterButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.484'!
chapterNameLabel
	"No description given."
	
	^ chapterNameLabel! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.336'!
codeEdit
	"No description given."
	
	^ codeEdit! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.132'!
hintButton
	"No description given."
	
	^ hintButton! !

!I2STaskUi methodsFor: 'ui - private' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.681'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 unnamedMorph2 unnamedMorph3 unnamedMorph4 unnamedMorph5 unnamedMorph6 unnamedMorph7 unnamedMorph8 unnamedMorph9 unnamedMorph10 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (800@600).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#leftToRight).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	panel color: ((Color r: 0.884 g: 0.884 b: 0.884)).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	stack := UiStackedWidget new.
	stack changeTableLayout.
	stack extent: (792@592).
	stack position: (4@4).
	stack hResizing: (#spaceFill).
	stack vResizing: (#spaceFill).
	stack minWidth: (2).
	stack minHeight: (2).
	stack cellInset: (4).
	stack cellPositioning: (#center).
	stack cellSpacing: (#none).
	stack layoutInset: (0).
	stack listCentering: (#topLeft).
	stack listDirection: (#topToBottom).
	stack listSpacing: (#none).
	stack maxCellSize: (1073741823).
	stack minCellSize: (0).
	stack wrapCentering: (#topLeft).
	stack wrapDirection: (#none).
	stack frameFractions: (0@0 corner: 1@1).
	stack frameOffsets: (0@0 corner: 0@0).
	stack balloonText: (nil).
	stack balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	stack color: (Color transparent).
	stack borderWidth: (0).
	stack borderStyle2: (#simple).
	stack borderColor: (Color black).
	stack setProperty: #objectName toValue: 'stack'.
	titleMenu := UiWidgetPage new.
	titleMenu changeTableLayout.
	titleMenu extent: (616@505).
	titleMenu position: (4@4).
	titleMenu hResizing: (#spaceFill).
	titleMenu vResizing: (#spaceFill).
	titleMenu minWidth: (2).
	titleMenu minHeight: (2).
	titleMenu cellInset: (30).
	titleMenu cellPositioning: (#center).
	titleMenu cellSpacing: (#none).
	titleMenu layoutInset: (4).
	titleMenu listCentering: (#center).
	titleMenu listDirection: (#topToBottom).
	titleMenu listSpacing: (#none).
	titleMenu maxCellSize: (1073741823).
	titleMenu minCellSize: (0).
	titleMenu wrapCentering: (#center).
	titleMenu wrapDirection: (#topToBottom).
	titleMenu frameFractions: (0@0 corner: 1@1).
	titleMenu frameOffsets: (0@0 corner: 0@0).
	titleMenu balloonText: (nil).
	titleMenu balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	titleMenu color: (Color transparent).
	titleMenu borderWidth: (0).
	titleMenu borderStyle2: (#simple).
	titleMenu borderColor: (Color black).
	titleMenu setProperty: #objectName toValue: 'titleMenu'.
	stack addChild: titleMenu.
	unnamedMorph1 := UiWidgetPage new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (616@505).
	unnamedMorph1 position: (4@4).
	unnamedMorph1 hResizing: (#spaceFill).
	unnamedMorph1 vResizing: (#spaceFill).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	unnamedMorph2 := UiContainer new.
	unnamedMorph2 changeTableLayout.
	unnamedMorph2 extent: (364@497).
	unnamedMorph2 position: (8@8).
	unnamedMorph2 hResizing: (#spaceFill).
	unnamedMorph2 vResizing: (#spaceFill).
	unnamedMorph2 minWidth: (2).
	unnamedMorph2 minHeight: (2).
	unnamedMorph2 cellInset: (4).
	unnamedMorph2 cellPositioning: (#center).
	unnamedMorph2 cellSpacing: (#none).
	unnamedMorph2 layoutInset: (4).
	unnamedMorph2 listCentering: (#topLeft).
	unnamedMorph2 listDirection: (#topToBottom).
	unnamedMorph2 listSpacing: (#none).
	unnamedMorph2 maxCellSize: (1073741823).
	unnamedMorph2 minCellSize: (0).
	unnamedMorph2 wrapCentering: (#topLeft).
	unnamedMorph2 wrapDirection: (#none).
	unnamedMorph2 frameFractions: (0@0 corner: 1@1).
	unnamedMorph2 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph2 balloonText: (nil).
	unnamedMorph2 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph2 color: (Color transparent).
	unnamedMorph2 borderWidth: (0).
	unnamedMorph2 borderStyle2: (#simple).
	unnamedMorph2 borderColor: (Color black).
	taskDescription := UiTextEdit new.
	taskDescription extent: (356@70).
	taskDescription position: (12@13).
	taskDescription hResizing: (#spaceFill).
	taskDescription vResizing: (#rigid).
	taskDescription minWidth: (2).
	taskDescription minHeight: (2).
	taskDescription cellInset: (0).
	taskDescription cellPositioning: (#center).
	taskDescription cellSpacing: (#none).
	taskDescription layoutInset: (0).
	taskDescription listCentering: (#topLeft).
	taskDescription listDirection: (#topToBottom).
	taskDescription listSpacing: (#none).
	taskDescription maxCellSize: (1073741823).
	taskDescription minCellSize: (0).
	taskDescription wrapCentering: (#topLeft).
	taskDescription wrapDirection: (#none).
	taskDescription frameFractions: (0@0 corner: 1@1).
	taskDescription frameOffsets: (0@0 corner: 0@0).
	taskDescription balloonText: (nil).
	taskDescription balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	taskDescription widgetResizable: (true).
	taskDescription horizontalScrollBarPolicy: (#alwaysOff).
	taskDescription verticalScrollBarPolicy: (#alwaysOn).
	taskDescription outerBorderWidth: (1).
	taskDescription scrollBarThickness: (9).
	taskDescription theText: ('').
	taskDescription readOnly: (false).
	taskDescription autoConvert: (false).
	taskDescription autoAccept: (false).
	taskDescription acceptOnFocusLost: (false).
	taskDescription scrollingMode: (#none).
	taskDescription scrollingLimit: (10).
	taskDescription setProperty: #objectName toValue: 'taskDescription'.
	unnamedMorph2 addChild: taskDescription.
	scrollArea := ViScrollArea new.
	scrollArea extent: (356@413).
	scrollArea position: (12@88).
	scrollArea hResizing: (#spaceFill).
	scrollArea vResizing: (#spaceFill).
	scrollArea minWidth: (2).
	scrollArea minHeight: (2).
	scrollArea cellInset: (0).
	scrollArea cellPositioning: (#center).
	scrollArea cellSpacing: (#none).
	scrollArea layoutInset: (0).
	scrollArea listCentering: (#topLeft).
	scrollArea listDirection: (#topToBottom).
	scrollArea listSpacing: (#none).
	scrollArea maxCellSize: (1073741823).
	scrollArea minCellSize: (0).
	scrollArea wrapCentering: (#topLeft).
	scrollArea wrapDirection: (#none).
	scrollArea frameFractions: (0@0 corner: 1@1).
	scrollArea frameOffsets: (0@0 corner: 0@0).
	scrollArea balloonText: (nil).
	scrollArea balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	scrollArea widgetResizable: (false).
	scrollArea horizontalScrollBarPolicy: (#alwaysOn).
	scrollArea verticalScrollBarPolicy: (#alwaysOn).
	scrollArea outerBorderWidth: (0).
	scrollArea scrollBarThickness: (9).
	scrollArea setProperty: #objectName toValue: 'scrollArea'.
	unnamedMorph2 addChild: scrollArea.
	unnamedMorph1 addChild: unnamedMorph2.
	unnamedMorph3 := UiContainer new.
	unnamedMorph3 changeTableLayout.
	unnamedMorph3 extent: (240@497).
	unnamedMorph3 position: (376@8).
	unnamedMorph3 hResizing: (#rigid).
	unnamedMorph3 vResizing: (#spaceFill).
	unnamedMorph3 minWidth: (2).
	unnamedMorph3 minHeight: (2).
	unnamedMorph3 cellInset: (4).
	unnamedMorph3 cellPositioning: (#center).
	unnamedMorph3 cellSpacing: (#none).
	unnamedMorph3 layoutInset: (4).
	unnamedMorph3 listCentering: (#topLeft).
	unnamedMorph3 listDirection: (#topToBottom).
	unnamedMorph3 listSpacing: (#none).
	unnamedMorph3 maxCellSize: (1073741823).
	unnamedMorph3 minCellSize: (0).
	unnamedMorph3 wrapCentering: (#topLeft).
	unnamedMorph3 wrapDirection: (#none).
	unnamedMorph3 frameFractions: (0@0 corner: 1@1).
	unnamedMorph3 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph3 balloonText: (nil).
	unnamedMorph3 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph3 color: (Color transparent).
	unnamedMorph3 borderWidth: (0).
	unnamedMorph3 borderStyle2: (#simple).
	unnamedMorph3 borderColor: (Color black).
	unnamedMorph4 := UiContainer new.
	unnamedMorph4 changeTableLayout.
	unnamedMorph4 extent: (232@71).
	unnamedMorph4 position: (380@12).
	unnamedMorph4 hResizing: (#spaceFill).
	unnamedMorph4 vResizing: (#shrinkWrap).
	unnamedMorph4 minWidth: (2).
	unnamedMorph4 minHeight: (2).
	unnamedMorph4 cellInset: (4).
	unnamedMorph4 cellPositioning: (#center).
	unnamedMorph4 cellSpacing: (#none).
	unnamedMorph4 layoutInset: (4).
	unnamedMorph4 listCentering: (#topLeft).
	unnamedMorph4 listDirection: (#leftToRight).
	unnamedMorph4 listSpacing: (#none).
	unnamedMorph4 maxCellSize: (1073741823).
	unnamedMorph4 minCellSize: (0).
	unnamedMorph4 wrapCentering: (#topLeft).
	unnamedMorph4 wrapDirection: (#none).
	unnamedMorph4 frameFractions: (0@0 corner: 1@1).
	unnamedMorph4 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph4 balloonText: (nil).
	unnamedMorph4 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph4 color: (Color transparent).
	unnamedMorph4 borderWidth: (0).
	unnamedMorph4 borderStyle2: (#simple).
	unnamedMorph4 borderColor: (Color black).
	unnamedMorph5 := UiContainer new.
	unnamedMorph5 changeTableLayout.
	unnamedMorph5 extent: (109@63).
	unnamedMorph5 position: (384@16).
	unnamedMorph5 hResizing: (#rigid).
	unnamedMorph5 vResizing: (#shrinkWrap).
	unnamedMorph5 minWidth: (2).
	unnamedMorph5 minHeight: (2).
	unnamedMorph5 cellInset: (4).
	unnamedMorph5 cellPositioning: (#center).
	unnamedMorph5 cellSpacing: (#none).
	unnamedMorph5 layoutInset: (4).
	unnamedMorph5 listCentering: (#topLeft).
	unnamedMorph5 listDirection: (#topToBottom).
	unnamedMorph5 listSpacing: (#none).
	unnamedMorph5 maxCellSize: (1073741823).
	unnamedMorph5 minCellSize: (0).
	unnamedMorph5 wrapCentering: (#topLeft).
	unnamedMorph5 wrapDirection: (#none).
	unnamedMorph5 frameFractions: (0@0 corner: 1@1).
	unnamedMorph5 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph5 balloonText: (nil).
	unnamedMorph5 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph5 color: (Color transparent).
	unnamedMorph5 borderWidth: (0).
	unnamedMorph5 borderStyle2: (#simple).
	unnamedMorph5 borderColor: (Color black).
	levelButton := UiPushButton new.
	levelButton changeTableLayout.
	levelButton extent: (70@21).
	levelButton position: (388@20).
	levelButton hResizing: (#spaceFill).
	levelButton vResizing: (#shrinkWrap).
	levelButton minWidth: (2).
	levelButton minHeight: (2).
	levelButton cellInset: (4).
	levelButton cellPositioning: (#center).
	levelButton cellSpacing: (#none).
	levelButton layoutInset: (2).
	levelButton listCentering: (#center).
	levelButton listDirection: (#leftToRight).
	levelButton listSpacing: (#none).
	levelButton maxCellSize: (1073741823).
	levelButton minCellSize: (0).
	levelButton wrapCentering: (#topLeft).
	levelButton wrapDirection: (#none).
	levelButton frameFractions: (0@0 corner: 1@1).
	levelButton frameOffsets: (0@0 corner: 0@0).
	levelButton balloonText: (nil).
	levelButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.933)).
	levelButton enabled: (true).
	levelButton setProperty: #iconByDesigner toValue: 'nil'.
	levelButton icon: (nil).
	levelButton text: ('Levels').
	levelButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	levelButton checkable: (false).
	levelButton checked: (false).
	levelButton autoExclusive: (false).
	levelButton setProperty: #objectName toValue: 'levelButton'.
	unnamedMorph5 addChild: levelButton.
	hintButton := UiPushButton new.
	hintButton changeTableLayout.
	hintButton extent: (70@21).
	hintButton position: (388@49).
	hintButton hResizing: (#spaceFill).
	hintButton vResizing: (#shrinkWrap).
	hintButton minWidth: (2).
	hintButton minHeight: (2).
	hintButton cellInset: (4).
	hintButton cellPositioning: (#center).
	hintButton cellSpacing: (#none).
	hintButton layoutInset: (2).
	hintButton listCentering: (#center).
	hintButton listDirection: (#leftToRight).
	hintButton listSpacing: (#none).
	hintButton maxCellSize: (1073741823).
	hintButton minCellSize: (0).
	hintButton wrapCentering: (#topLeft).
	hintButton wrapDirection: (#none).
	hintButton frameFractions: (0@0 corner: 1@1).
	hintButton frameOffsets: (0@0 corner: 0@0).
	hintButton balloonText: (nil).
	hintButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	hintButton enabled: (true).
	hintButton setProperty: #iconByDesigner toValue: 'nil'.
	hintButton icon: (nil).
	hintButton text: ('Hint').
	hintButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	hintButton checkable: (false).
	hintButton checked: (false).
	hintButton autoExclusive: (false).
	hintButton setProperty: #objectName toValue: 'hintButton'.
	unnamedMorph5 addChild: hintButton.
	unnamedMorph4 addChild: unnamedMorph5.
	unnamedMorph6 := UiContainer new.
	unnamedMorph6 changeTableLayout.
	unnamedMorph6 extent: (109@63).
	unnamedMorph6 position: (497@16).
	unnamedMorph6 hResizing: (#rigid).
	unnamedMorph6 vResizing: (#shrinkWrap).
	unnamedMorph6 minWidth: (2).
	unnamedMorph6 minHeight: (2).
	unnamedMorph6 cellInset: (4).
	unnamedMorph6 cellPositioning: (#center).
	unnamedMorph6 cellSpacing: (#none).
	unnamedMorph6 layoutInset: (4).
	unnamedMorph6 listCentering: (#topLeft).
	unnamedMorph6 listDirection: (#topToBottom).
	unnamedMorph6 listSpacing: (#none).
	unnamedMorph6 maxCellSize: (1073741823).
	unnamedMorph6 minCellSize: (0).
	unnamedMorph6 wrapCentering: (#topLeft).
	unnamedMorph6 wrapDirection: (#none).
	unnamedMorph6 frameFractions: (0@0 corner: 1@1).
	unnamedMorph6 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph6 balloonText: (nil).
	unnamedMorph6 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph6 color: (Color transparent).
	unnamedMorph6 borderWidth: (0).
	unnamedMorph6 borderStyle2: (#simple).
	unnamedMorph6 borderColor: (Color black).
	resetButton := UiPushButton new.
	resetButton changeTableLayout.
	resetButton extent: (70@21).
	resetButton position: (501@20).
	resetButton hResizing: (#spaceFill).
	resetButton vResizing: (#shrinkWrap).
	resetButton minWidth: (2).
	resetButton minHeight: (2).
	resetButton cellInset: (4).
	resetButton cellPositioning: (#center).
	resetButton cellSpacing: (#none).
	resetButton layoutInset: (2).
	resetButton listCentering: (#center).
	resetButton listDirection: (#leftToRight).
	resetButton listSpacing: (#none).
	resetButton maxCellSize: (1073741823).
	resetButton minCellSize: (0).
	resetButton wrapCentering: (#topLeft).
	resetButton wrapDirection: (#none).
	resetButton frameFractions: (0@0 corner: 1@1).
	resetButton frameOffsets: (0@0 corner: 0@0).
	resetButton balloonText: (nil).
	resetButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.933)).
	resetButton enabled: (true).
	resetButton setProperty: #iconByDesigner toValue: 'nil'.
	resetButton icon: (nil).
	resetButton text: ('Reset').
	resetButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	resetButton checkable: (false).
	resetButton checked: (false).
	resetButton autoExclusive: (false).
	resetButton setProperty: #objectName toValue: 'resetButton'.
	unnamedMorph6 addChild: resetButton.
	solutionButton := UiPushButton new.
	solutionButton changeTableLayout.
	solutionButton extent: (70@21).
	solutionButton position: (501@49).
	solutionButton hResizing: (#spaceFill).
	solutionButton vResizing: (#shrinkWrap).
	solutionButton minWidth: (2).
	solutionButton minHeight: (2).
	solutionButton cellInset: (4).
	solutionButton cellPositioning: (#center).
	solutionButton cellSpacing: (#none).
	solutionButton layoutInset: (2).
	solutionButton listCentering: (#center).
	solutionButton listDirection: (#leftToRight).
	solutionButton listSpacing: (#none).
	solutionButton maxCellSize: (1073741823).
	solutionButton minCellSize: (0).
	solutionButton wrapCentering: (#topLeft).
	solutionButton wrapDirection: (#none).
	solutionButton frameFractions: (0@0 corner: 1@1).
	solutionButton frameOffsets: (0@0 corner: 0@0).
	solutionButton balloonText: (nil).
	solutionButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.933)).
	solutionButton enabled: (true).
	solutionButton setProperty: #iconByDesigner toValue: 'nil'.
	solutionButton icon: (nil).
	solutionButton text: ('Solution').
	solutionButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	solutionButton checkable: (false).
	solutionButton checked: (false).
	solutionButton autoExclusive: (false).
	solutionButton setProperty: #objectName toValue: 'solutionButton'.
	unnamedMorph6 addChild: solutionButton.
	unnamedMorph4 addChild: unnamedMorph6.
	unnamedMorph3 addChild: unnamedMorph4.
	parameterDisplay := UiTextEdit new.
	parameterDisplay extent: (232@70).
	parameterDisplay position: (380@88).
	parameterDisplay hResizing: (#spaceFill).
	parameterDisplay vResizing: (#rigid).
	parameterDisplay minWidth: (2).
	parameterDisplay minHeight: (2).
	parameterDisplay cellInset: (0).
	parameterDisplay cellPositioning: (#center).
	parameterDisplay cellSpacing: (#none).
	parameterDisplay layoutInset: (0).
	parameterDisplay listCentering: (#topLeft).
	parameterDisplay listDirection: (#topToBottom).
	parameterDisplay listSpacing: (#none).
	parameterDisplay maxCellSize: (1073741823).
	parameterDisplay minCellSize: (0).
	parameterDisplay wrapCentering: (#topLeft).
	parameterDisplay wrapDirection: (#none).
	parameterDisplay frameFractions: (0@0 corner: 1@1).
	parameterDisplay frameOffsets: (0@0 corner: 0@0).
	parameterDisplay balloonText: (nil).
	parameterDisplay balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	parameterDisplay widgetResizable: (true).
	parameterDisplay horizontalScrollBarPolicy: (#alwaysOff).
	parameterDisplay verticalScrollBarPolicy: (#alwaysOn).
	parameterDisplay outerBorderWidth: (1).
	parameterDisplay scrollBarThickness: (9).
	parameterDisplay theText: ('find: aValue').
	parameterDisplay readOnly: (false).
	parameterDisplay autoConvert: (false).
	parameterDisplay autoAccept: (false).
	parameterDisplay acceptOnFocusLost: (false).
	parameterDisplay scrollingMode: (#none).
	parameterDisplay scrollingLimit: (10).
	parameterDisplay setProperty: #objectName toValue: 'parameterDisplay'.
	unnamedMorph3 addChild: parameterDisplay.
	codeEdit := ViSourceCodeEdit new.
	codeEdit extent: (232@292).
	codeEdit position: (380@163).
	codeEdit hResizing: (#spaceFill).
	codeEdit vResizing: (#spaceFill).
	codeEdit minWidth: (2).
	codeEdit minHeight: (2).
	codeEdit cellInset: (0).
	codeEdit cellPositioning: (#center).
	codeEdit cellSpacing: (#none).
	codeEdit layoutInset: (0).
	codeEdit listCentering: (#topLeft).
	codeEdit listDirection: (#topToBottom).
	codeEdit listSpacing: (#none).
	codeEdit maxCellSize: (1073741823).
	codeEdit minCellSize: (0).
	codeEdit wrapCentering: (#topLeft).
	codeEdit wrapDirection: (#none).
	codeEdit frameFractions: (0@0 corner: 1@1).
	codeEdit frameOffsets: (0@0 corner: 0@0).
	codeEdit balloonText: (nil).
	codeEdit balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	codeEdit widgetResizable: (true).
	codeEdit horizontalScrollBarPolicy: (#alwaysOff).
	codeEdit verticalScrollBarPolicy: (#alwaysOn).
	codeEdit outerBorderWidth: (1).
	codeEdit scrollBarThickness: (9).
	codeEdit theText: ('').
	codeEdit readOnly: (false).
	codeEdit autoConvert: (false).
	codeEdit autoAccept: (false).
	codeEdit acceptOnFocusLost: (false).
	codeEdit scrollingMode: (#none).
	codeEdit scrollingLimit: (10).
	codeEdit setProperty: #objectName toValue: 'codeEdit'.
	unnamedMorph3 addChild: codeEdit.
	unnamedMorph7 := UiContainer new.
	unnamedMorph7 changeTableLayout.
	unnamedMorph7 extent: (232@42).
	unnamedMorph7 position: (380@459).
	unnamedMorph7 hResizing: (#spaceFill).
	unnamedMorph7 vResizing: (#shrinkWrap).
	unnamedMorph7 minWidth: (2).
	unnamedMorph7 minHeight: (2).
	unnamedMorph7 cellInset: (4).
	unnamedMorph7 cellPositioning: (#center).
	unnamedMorph7 cellSpacing: (#none).
	unnamedMorph7 layoutInset: (4).
	unnamedMorph7 listCentering: (#topLeft).
	unnamedMorph7 listDirection: (#leftToRight).
	unnamedMorph7 listSpacing: (#none).
	unnamedMorph7 maxCellSize: (1073741823).
	unnamedMorph7 minCellSize: (0).
	unnamedMorph7 wrapCentering: (#topLeft).
	unnamedMorph7 wrapDirection: (#none).
	unnamedMorph7 frameFractions: (0@0 corner: 1@1).
	unnamedMorph7 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph7 balloonText: (nil).
	unnamedMorph7 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph7 color: (Color transparent).
	unnamedMorph7 borderWidth: (0).
	unnamedMorph7 borderStyle2: (#simple).
	unnamedMorph7 borderColor: (Color black).
	unnamedMorph8 := UiContainer new.
	unnamedMorph8 changeTableLayout.
	unnamedMorph8 extent: (109@34).
	unnamedMorph8 position: (384@463).
	unnamedMorph8 hResizing: (#rigid).
	unnamedMorph8 vResizing: (#shrinkWrap).
	unnamedMorph8 minWidth: (2).
	unnamedMorph8 minHeight: (2).
	unnamedMorph8 cellInset: (4).
	unnamedMorph8 cellPositioning: (#center).
	unnamedMorph8 cellSpacing: (#none).
	unnamedMorph8 layoutInset: (4).
	unnamedMorph8 listCentering: (#topLeft).
	unnamedMorph8 listDirection: (#topToBottom).
	unnamedMorph8 listSpacing: (#none).
	unnamedMorph8 maxCellSize: (1073741823).
	unnamedMorph8 minCellSize: (0).
	unnamedMorph8 wrapCentering: (#topLeft).
	unnamedMorph8 wrapDirection: (#none).
	unnamedMorph8 frameFractions: (0@0 corner: 1@1).
	unnamedMorph8 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph8 balloonText: (nil).
	unnamedMorph8 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph8 color: (Color transparent).
	unnamedMorph8 borderWidth: (0).
	unnamedMorph8 borderStyle2: (#simple).
	unnamedMorph8 borderColor: (Color black).
	playButton := UiPushButton new.
	playButton changeTableLayout.
	playButton extent: (70@21).
	playButton position: (388@467).
	playButton hResizing: (#spaceFill).
	playButton vResizing: (#shrinkWrap).
	playButton minWidth: (2).
	playButton minHeight: (2).
	playButton cellInset: (4).
	playButton cellPositioning: (#center).
	playButton cellSpacing: (#none).
	playButton layoutInset: (2).
	playButton listCentering: (#center).
	playButton listDirection: (#leftToRight).
	playButton listSpacing: (#none).
	playButton maxCellSize: (1073741823).
	playButton minCellSize: (0).
	playButton wrapCentering: (#topLeft).
	playButton wrapDirection: (#none).
	playButton frameFractions: (0@0 corner: 1@1).
	playButton frameOffsets: (0@0 corner: 0@0).
	playButton balloonText: (nil).
	playButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	playButton enabled: (true).
	playButton setProperty: #iconByDesigner toValue: 'nil'.
	playButton icon: (nil).
	playButton text: ('Play').
	playButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	playButton checkable: (false).
	playButton checked: (false).
	playButton autoExclusive: (false).
	playButton setProperty: #objectName toValue: 'playButton'.
	unnamedMorph8 addChild: playButton.
	unnamedMorph7 addChild: unnamedMorph8.
	unnamedMorph9 := UiContainer new.
	unnamedMorph9 changeTableLayout.
	unnamedMorph9 extent: (109@34).
	unnamedMorph9 position: (497@463).
	unnamedMorph9 hResizing: (#rigid).
	unnamedMorph9 vResizing: (#shrinkWrap).
	unnamedMorph9 minWidth: (2).
	unnamedMorph9 minHeight: (2).
	unnamedMorph9 cellInset: (4).
	unnamedMorph9 cellPositioning: (#center).
	unnamedMorph9 cellSpacing: (#none).
	unnamedMorph9 layoutInset: (4).
	unnamedMorph9 listCentering: (#topLeft).
	unnamedMorph9 listDirection: (#topToBottom).
	unnamedMorph9 listSpacing: (#none).
	unnamedMorph9 maxCellSize: (1073741823).
	unnamedMorph9 minCellSize: (0).
	unnamedMorph9 wrapCentering: (#topLeft).
	unnamedMorph9 wrapDirection: (#none).
	unnamedMorph9 frameFractions: (0@0 corner: 1@1).
	unnamedMorph9 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph9 balloonText: (nil).
	unnamedMorph9 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.941)).
	unnamedMorph9 color: (Color transparent).
	unnamedMorph9 borderWidth: (0).
	unnamedMorph9 borderStyle2: (#simple).
	unnamedMorph9 borderColor: (Color black).
	stepButton := UiPushButton new.
	stepButton changeTableLayout.
	stepButton extent: (70@21).
	stepButton position: (501@467).
	stepButton hResizing: (#spaceFill).
	stepButton vResizing: (#shrinkWrap).
	stepButton minWidth: (2).
	stepButton minHeight: (2).
	stepButton cellInset: (4).
	stepButton cellPositioning: (#center).
	stepButton cellSpacing: (#none).
	stepButton layoutInset: (2).
	stepButton listCentering: (#center).
	stepButton listDirection: (#leftToRight).
	stepButton listSpacing: (#none).
	stepButton maxCellSize: (1073741823).
	stepButton minCellSize: (0).
	stepButton wrapCentering: (#topLeft).
	stepButton wrapDirection: (#none).
	stepButton frameFractions: (0@0 corner: 1@1).
	stepButton frameOffsets: (0@0 corner: 0@0).
	stepButton balloonText: (nil).
	stepButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.933)).
	stepButton enabled: (true).
	stepButton setProperty: #iconByDesigner toValue: 'nil'.
	stepButton icon: (nil).
	stepButton text: ('Step').
	stepButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	stepButton checkable: (false).
	stepButton checked: (false).
	stepButton autoExclusive: (false).
	stepButton setProperty: #objectName toValue: 'stepButton'.
	unnamedMorph9 addChild: stepButton.
	unnamedMorph7 addChild: unnamedMorph9.
	unnamedMorph3 addChild: unnamedMorph7.
	unnamedMorph1 addChild: unnamedMorph3.
	stack addChild: unnamedMorph1.
	unnamedMorph10 := UiWidgetPage new.
	unnamedMorph10 changeTableLayout.
	unnamedMorph10 extent: (792@592).
	unnamedMorph10 position: (4@4).
	unnamedMorph10 hResizing: (#spaceFill).
	unnamedMorph10 vResizing: (#spaceFill).
	unnamedMorph10 minWidth: (2).
	unnamedMorph10 minHeight: (2).
	unnamedMorph10 cellInset: (4).
	unnamedMorph10 cellPositioning: (#center).
	unnamedMorph10 cellSpacing: (#none).
	unnamedMorph10 layoutInset: (4).
	unnamedMorph10 listCentering: (#topLeft).
	unnamedMorph10 listDirection: (#topToBottom).
	unnamedMorph10 listSpacing: (#none).
	unnamedMorph10 maxCellSize: (1073741823).
	unnamedMorph10 minCellSize: (0).
	unnamedMorph10 wrapCentering: (#topLeft).
	unnamedMorph10 wrapDirection: (#none).
	unnamedMorph10 frameFractions: (0@0 corner: 1@1).
	unnamedMorph10 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph10 balloonText: (nil).
	unnamedMorph10 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.929)).
	unnamedMorph10 color: (Color transparent).
	unnamedMorph10 borderWidth: (0).
	unnamedMorph10 borderStyle2: (#simple).
	unnamedMorph10 borderColor: (Color black).
	chapterNameLabel := UiLabel new.
	chapterNameLabel changeTableLayout.
	chapterNameLabel extent: (31@19).
	chapterNameLabel position: (385@8).
	chapterNameLabel hResizing: (#shrinkWrap).
	chapterNameLabel vResizing: (#shrinkWrap).
	chapterNameLabel minWidth: (2).
	chapterNameLabel minHeight: (2).
	chapterNameLabel cellInset: (0).
	chapterNameLabel cellPositioning: (#center).
	chapterNameLabel cellSpacing: (#none).
	chapterNameLabel layoutInset: (0).
	chapterNameLabel listCentering: (#topLeft).
	chapterNameLabel listDirection: (#leftToRight).
	chapterNameLabel listSpacing: (#none).
	chapterNameLabel maxCellSize: (1073741823).
	chapterNameLabel minCellSize: (0).
	chapterNameLabel wrapCentering: (#topLeft).
	chapterNameLabel wrapDirection: (#none).
	chapterNameLabel frameFractions: (0@0 corner: 1@1).
	chapterNameLabel frameOffsets: (0@0 corner: 0@0).
	chapterNameLabel balloonText: (nil).
	chapterNameLabel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.929)).
	chapterNameLabel text: ('Label').
	chapterNameLabel setProperty: #formByDesigner toValue: 'nil'.
	chapterNameLabel form: (nil).
	chapterNameLabel setProperty: #objectName toValue: 'chapterNameLabel'.
	unnamedMorph10 addChild: chapterNameLabel.
	levelButtonContainer := UiContainer new.
	levelButtonContainer changeTableLayout.
	levelButtonContainer extent: (784@534).
	levelButtonContainer position: (8@31).
	levelButtonContainer hResizing: (#spaceFill).
	levelButtonContainer vResizing: (#spaceFill).
	levelButtonContainer minWidth: (2).
	levelButtonContainer minHeight: (2).
	levelButtonContainer cellInset: (20).
	levelButtonContainer cellPositioning: (#center).
	levelButtonContainer cellSpacing: (#none).
	levelButtonContainer layoutInset: (4).
	levelButtonContainer listCentering: (#center).
	levelButtonContainer listDirection: (#topToBottom).
	levelButtonContainer listSpacing: (#none).
	levelButtonContainer maxCellSize: (1073741823).
	levelButtonContainer minCellSize: (0).
	levelButtonContainer wrapCentering: (#center).
	levelButtonContainer wrapDirection: (#topToBottom).
	levelButtonContainer frameFractions: (0@0 corner: 1@1).
	levelButtonContainer frameOffsets: (0@0 corner: 0@0).
	levelButtonContainer balloonText: (nil).
	levelButtonContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.929)).
	levelButtonContainer color: (Color transparent).
	levelButtonContainer borderWidth: (0).
	levelButtonContainer borderStyle2: (#simple).
	levelButtonContainer borderColor: (Color black).
	levelButtonContainer setProperty: #objectName toValue: 'levelButtonContainer'.
	unnamedMorph10 addChild: levelButtonContainer.
	chapterButton := UiPushButton new.
	chapterButton changeTableLayout.
	chapterButton extent: (58@21).
	chapterButton position: (371@570).
	chapterButton hResizing: (#shrinkWrap).
	chapterButton vResizing: (#shrinkWrap).
	chapterButton minWidth: (2).
	chapterButton minHeight: (2).
	chapterButton cellInset: (4).
	chapterButton cellPositioning: (#center).
	chapterButton cellSpacing: (#none).
	chapterButton layoutInset: (2@0 corner: 2@0).
	chapterButton listCentering: (#topLeft).
	chapterButton listDirection: (#leftToRight).
	chapterButton listSpacing: (#none).
	chapterButton maxCellSize: (1073741823).
	chapterButton minCellSize: (0).
	chapterButton wrapCentering: (#topLeft).
	chapterButton wrapDirection: (#none).
	chapterButton frameFractions: (0@0 corner: 1@1).
	chapterButton frameOffsets: (0@0 corner: 0@0).
	chapterButton balloonText: (nil).
	chapterButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	chapterButton enabled: (true).
	chapterButton setProperty: #iconByDesigner toValue: 'nil'.
	chapterButton icon: (nil).
	chapterButton text: ('Chapters').
	chapterButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	chapterButton checkable: (false).
	chapterButton checked: (false).
	chapterButton autoExclusive: (false).
	chapterButton setProperty: #objectName toValue: 'chapterButton'.
	unnamedMorph10 addChild: chapterButton.
	stack addChild: unnamedMorph10.
	panel addChild: stack.
	panel setProperty: #uiClassName toValue: 'I2STask'.! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.083'!
levelButton
	"No description given."
	
	^ levelButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.542'!
levelButtonContainer
	"No description given."
	
	^ levelButtonContainer! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.282'!
parameterDisplay
	"No description given."
	
	^ parameterDisplay! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.383'!
playButton
	"No description given."
	
	^ playButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.183'!
resetButton
	"No description given."
	
	^ resetButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.025'!
scrollArea
	"No description given."
	
	^ scrollArea! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.233'!
solutionButton
	"No description given."
	
	^ solutionButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:31.863'!
stack
	"No description given."
	
	^ stack! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:32.433'!
stepButton
	"No description given."
	
	^ stepButton! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:31.972'!
taskDescription
	"No description given."
	
	^ taskDescription! !

!I2STaskUi methodsFor: 'accessing' stamp: 'benjamin.siegmund 6/26/2013 15:43:31.919'!
titleMenu
	"No description given."
	
	^ titleMenu! !

Morph subclass: #I2SListElementMorph
	instanceVariableNames: 'active value text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 16:17:34.599'!
activate
	active := true.
	text color: Color black.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 14:47:39.195'!
alignText
	text position: ((self extent - text extent) / 2).! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 14:56:25.359'!
buildText
	text := TextMorph new.
	text contents: (value asString).
	text lock: true.
	text color: Color transparent.
	self addMorph: text.
	self alignText.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:56:58.197'!
clickedOn: aListElementMorph
	self emit.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:15:23.053'!
deactivate
	active := false.
	text color: Color transparent.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:45:53.6'!
defaultBounds
	^0@0 corner: 50@50! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 15:11:09.039'!
initialize
	super initialize.
	
	self borderWidth: 1.
	self borderColor: Color black.
	self color: Color white.
	
	active := false.
	value := 0.
	self buildText.
	
	self on: #click send: #onClick to: self.
	self on: #mouseEnter send: #onMouseEnter to: self.
	self on: #mouseLeave send: #onMouseLeave to: self.! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 11:25:11.222'!
onClick
	self owner ignoreMouse ifFalse: [
		active ifFalse: [
			self owner activeElement: self.
		] ifTrue: [
			self owner activeElement: nil.
		].
		self clickedOn: self.
	].! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 11:27:40.885'!
onMouseEnter
	self owner ignoreMouse ifFalse: [	
		self color: Color yellow muchLighter.
	].! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 11:28:01.491'!
onMouseLeave
	self owner ignoreMouse ifFalse: [
		self color: Color white.
	].! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 14:28:11.813'!
value
	^value! !

!I2SListElementMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:36:28.677'!
value: aValue.
	value := aValue.
	text contents: aValue asString.
	self alignText.! !

Morph subclass: #I2SListMorph
	instanceVariableNames: 'activeElement list ignoreMouse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SListMorph class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 13:10:36.836'!
newWithList: aList
	|out|
	
	out := self new.
	out list: aList.
	out draw.
	^out! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 16:04:04.271'!
actionPerformed
	self emit.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:00.362'!
activeElement
	^activeElement! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 16:07:30.941'!
activeElement: anElement.
	self actionPerformed.

	activeElement ifNotNil:[
		activeElement deactivate.	
	].	
	activeElement := anElement.
	anElement ifNotNil:[
		anElement activate.
		self valueSelected: anElement value.
	].! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:50:50.297'!
draw
	| offset |
	
	offset := 0.
	
	self list do: [:ea| |morph|
		morph := I2SListElementMorph new.
		morph value: ea.
		morph left: offset.
		self addMorph: morph.
		offset := offset + morph width.].
	
	self extent: self fullBounds extent.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 11:23:53.834'!
ignoreMouse
	^ignoreMouse! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 11:24:05.144'!
ignoreMouse: aBoolean
	ignoreMouse := aBoolean.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 11:33:35.703'!
initialize
	super initialize.
	self color: Color transparent.
	self borderWidth: 1.
	self borderColor: Color black.
	self ignoreMouse: false.
	
	activeElement := nil.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 15:51:10.933'!
list
	list ifNil:[
		list := {}.	
	].
	^list! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 12:01:35.303'!
list: aList.
	list := aList.! !

!I2SListMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 14:57:09.673'!
valueSelected: aValue
	self emit.! !

I2SListMorph subclass: #I2SVisualizationListMorph
	instanceVariableNames: 'visualization parentEdge node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SVisualizationListMorph class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 17:08:18.385'!
defaultAnimationDuration

	^ 400! !

!I2SVisualizationListMorph class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 11:45:14.725'!
newWithList: aListNode on: aVisualization
	| s |
	s := self basicNew.
	s list: aListNode list.
	s node: aListNode.
	s visualization: aVisualization.
	s visualization setVisualNode: s for: aListNode.
	s initialize.
	s draw.
	^s.! !

!I2SVisualizationListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 10:21:17.554'!
draw
	super draw.
	self submorphs do: [ :ea |
		(ea isKindOf: I2SListElementMorph) ifTrue: [
			ea deactivate.
			self visualization connect: ea signal: #clickedOn: toSelector: #clickedOn:.
		].		
	].! !

!I2SVisualizationListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 11:37:56.295'!
ignoreMouse
	^self visualization ignoreMouse.! !

!I2SVisualizationListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 11:37:58.106'!
ignoreMouse: aBoolean
	self visualization ignoreMouse: aBoolean.! !

!I2SVisualizationListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 14:42:39.199'!
node
	^node! !

!I2SVisualizationListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 14:42:40.564'!
node: aNode
	node := aNode! !

!I2SVisualizationListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:25:43.747'!
parentEdge
	^parentEdge! !

!I2SVisualizationListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:25:44.946'!
parentEdge: anEdge
	parentEdge := anEdge! !

!I2SVisualizationListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:07:53.416'!
visualization
	^visualization! !

!I2SVisualizationListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 12:07:27.521'!
visualization: aVisualization
	visualization := aVisualization! !

!I2SVisualizationListMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 17:07:23.593'!
walkToPosition: aPoint then: aBlock

		(AnimPropertyAnimation
		on: self
		property: #position
		start: self position
		end: aPoint
		duration: self class defaultAnimationDuration)
		finishBlock: aBlock;
		register;
		start: #deleteWhenFinished.! !

Morph subclass: #I2SVisualListNode
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SVisualListNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 14:43:27.948'!
newWithNode: aNode on: aVisualization

aNode isListNode ifTrue: [
	^ I2SVisualizationListMorph newWithList: aNode on: aVisualization.
] ifFalse:[
	^ I2SVisualNode newWithNode: aNode on: aVisualization
]! !

!I2SVisualListNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 14:48:35.382'!
newWithNode: aNode renderDepth: aNumber on: aVisualization

aNode isListNode ifTrue: [
	^ I2SVisualizationListMorph newWithList: aNode on: aVisualization
] ifFalse:[
	^ I2SVisualNode newWithNode: aNode renderDepth: aNumber on: aVisualization
]! !

Morph subclass: #I2SVisualization
	instanceVariableNames: 'rootNode visualNodeMap ignoreMouse drawNil maxDepth activeNode ignoreSelection rotationHandle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

I2SVisualization subclass: #I2SBinaryTreeVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SBinaryTreeVisualization class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 15:45:17.284'!
newWithList: aList
	| root treeVis |
	
	root := I2SBinarySearchTreeNode newWithList: aList.
	treeVis := super newWithNode: root.
	
	^ treeVis	! !

I2SVisualization subclass: #I2SHybridVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SHybridVisualization class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 10:29:48.448'!
newWithList: aList
	^self newWithListNode: (I2SListNode newWithList: aList)! !

!I2SHybridVisualization class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 10:29:24.199'!
newWithListNode: aListNode
	^self newWithNode: aListNode! !

!I2SHybridVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 12:27:08.883'!
animatedRedrawFor: aNode replaceWith: newNode originalMorph: aListElementMorph
	| newVis callbackCounter nodePosition newTempVisNode |
	
	"hide parent Edge"
	self hideParentEdgeFor: aNode then: [
		
		"remove the old list"
		nodePosition := aListElementMorph position.
		(self visualNodeMap at: aNode) fadeOutThen: [
		
		"add add the three new morphs"
		newTempVisNode := I2SVisualNode newWithNode: newNode on: self.
		newTempVisNode position: nodePosition.
		newTempVisNode submorphs do: [
			:ea |
			(ea isKindOf: I2SVisualizationListMorph) ifTrue: [
				ea position: nodePosition.			
			].
		].
		newTempVisNode edges do: [
			:ea |
			ea ifNotNil: [
				ea delete.
			].
		].
		self addMorph: newTempVisNode.

		newVis := self class newWithNode: self rootNode.
		"iterate over own visnodes"
		visualNodeMap do: [:ea ||dataNode newVisNode|
			"get the data node for the visual node"
			dataNode := ea node.
			"find the corresponding visual node in the new tree"
			newVisNode := newVis getVisualNodeFor: dataNode.
		
			"animate the position of the current node to the new position"
			newVisNode ifNotNil: [
				ea walkToPosition: ((newVisNode position) + (self position)) then: [
					self redraw.
				].
			].
		].
	].
].! !

!I2SHybridVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/22/2013 10:36:39.602'!
clickedOn: aListElementMorph
	| node newNode parentVis leftList rightList |
	node := aListElementMorph owner node.
	"make new binary search tree node BSTN with the new value"
	newNode := I2SBinarySearchTreeNode newWithValue: aListElementMorph value.
	
	"split the list in left and right"
	leftList := node createLeftPart: aListElementMorph value.
	rightList := node createRightPart: aListElementMorph value.
		
	"set the new lists as left and right child of the BSTN"
	leftList list size > 0 ifTrue: [
		newNode leftChild: leftList.
	].
	rightList list size > 0 ifTrue: [
		newNode rightChild: rightList.
	].	
	
	node parent ifNil: [
		"in this case we are the root element"
		self rootNode: newNode.
	] ifNotNil: [
		"replace the list with the BSTN"
		parentVis := self visualNodeMap at: node parent.
		node parent replace: node with: newNode.
		
	].
	self animatedRedrawFor: node replaceWith: newNode originalMorph: aListElementMorph.
	
	self actionPerformed.
	self valueSelected: aListElementMorph value.
	! !

!I2SHybridVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 16:45:36.95'!
hideParentEdgeFor: aNode
! !

!I2SHybridVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 16:49:15.166'!
hideParentEdgeFor: aNode then: aBlock
	|visNode|
	visNode := self getVisualNodeFor: aNode.
	visNode parentEdge ifNotNil: [
		visNode parentEdge fadeOutThen: aBlock.
	] ifNil: [
		aBlock value.
	].
	! !

!I2SHybridVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/19/2013 16:14:33.772'!
redraw
	self updateTree.	! !

!I2SHybridVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 12:20:24.452'!
setRootNode: aRoot

	| visNode |
	self rootNode: aRoot.

  	visNode := (I2SVisualListNode newWithNode: aRoot on: self).
  	self addMorph: visNode.
	visNode visualization: self.
  	self extent: visNode fullBounds extent.
	visNode position: visNode position - self fullBounds topLeft + self position.
	
	visualNodeMap at: aRoot put: visNode .
  	^self! !

I2SVisualization subclass: #I2STreeSectionMorph
	instanceVariableNames: 'node leftMorph rightMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:24:55.794'!
childrenConnectorStart

	^50@100! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:25:22.139'!
currentNodePosition

	^ 30@60! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:25:18.908'!
leftChildPosition

	^ 0@120! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:25:25.964'!
leftConnectorEnd
	
	^20@120! !

!I2STreeSectionMorph class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/11/2013 15:36:50.937'!
newWithList: aList
 | a |
	a := self new.
	a node: (I2SBinarySearchTreeNode newWithList: aList).
	^a! !

!I2STreeSectionMorph class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 17:07:14.685'!
newWithNode: aNode
 | a |
	a := self new.
	a node: aNode.
	^a! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:37:51.574'!
parentConnectorEnd

 	^50@40! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:38:06.112'!
parentConnectorStart

	^50@60! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:38:01.496'!
parentNodePosition

	^ 30@0! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:37:59.251'!
rightChildPosition

	^ 60@120! !

!I2STreeSectionMorph class methodsFor: 'positioningConstants' stamp: 'dustin.glaeser 5/30/2013 17:37:55.185'!
rightConnectorEnd

	^80@120! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/30/2013 17:17:09.317'!
addNode: aNode atPosition: aPosition
	| node |
	node := (I2SVisualNode newWithNode: aNode renderDepth: 1 on: self).
	self addMorph: node.
	node position: (self position + aPosition).
	
	^ node! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/5/2013 17:41:21.206'!
animateGoLeftThen: aBlock

	(self getVisualNodeFor: self node) 
		walkToPosition: self position + self class parentNodePosition.
		
	(self getVisualNodeFor: self node leftChild ) 
		walkToPosition: self position + self class currentNodePosition
			then: [self finishGoLeftThen: aBlock].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 12:43:26.672'!
animateGoRightThen: aBlock

	(self getVisualNodeFor: self node) 
		walkToPosition: self position + self class parentNodePosition.
		
	(self getVisualNodeFor: self node rightChild) 
		walkToPosition: self position + self class currentNodePosition
			then: [self finishGoRightThen: aBlock].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 13:54:54.132'!
animateGoUpThen: aBlock

	| newPosition |
	(self node = (self node parent) leftChild)
		ifTrue: [newPosition := self class leftChildPosition]
		ifFalse: [newPosition := self class rightChildPosition].
		
	(self getVisualNodeFor: self node) 
		walkToPosition: self position + newPosition.
		
	(self getVisualNodeFor: self node parent) 
		walkToPosition: self position + self class currentNodePosition
			then: [self finishGoUpThen: aBlock].! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 12:28:55.198'!
clickLeft
	self ignoreMouse ifFalse:[
		self goLeft.
	].	! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 10:53:40.637'!
clickRight
	self ignoreMouse ifFalse:[
		self goRight.
	].	! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 10:54:03.4'!
clickUp
	self ignoreMouse ifFalse:[
		self goUp.
	].	! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 12:39:36.534'!
draw
	self drawThen: [].! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 14:48:36.131'!
drawConnectorFrom: aStart to: anEnd

	^ (LineMorph 
		from: (self position + aStart) 
		to: (self position + anEnd)
		color: Color black
		width: 5).! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/5/2013 16:26:37.86'!
drawCurrentNode
	| activeNodeMorph |
	activeNodeMorph := (I2SVisualNode newWithNode: self node renderDepth: 1 on: self).
	self addMorph: activeNodeMorph.
	activeNodeMorph position: (self position + self class currentNodePosition).! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/5/2013 14:59:42.226'!
drawEdgeFrom: aStart to: anEnd

	^ (LineMorph 
		from: (self position + aStart) 
		to: (self position + anEnd)
		color: Color black
		width: 5).! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 16:26:16.992'!
drawLeftChild

	| edge|
	leftMorph := self addNode: self node leftChild atPosition: self class leftChildPosition.
	
	leftMorph isBlank ifTrue: [
		leftMorph parent: (self getVisualNodeFor: self node).
		leftMorph parentChildNumber: 1.	
	] ifFalse: [
		leftMorph hideContent.
		leftMorph on: #click send: #clickLeft to: self.
	]. 
	
	edge := self drawEdgeFrom: self class childrenConnectorStart 
		to: self class leftConnectorEnd.
		
	leftMorph parentEdge: edge.
	self addMorph: edge.
	
	(self getVisualNodeFor: self node) childEdges add: edge.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/23/2013 10:21:42.26'!
drawParentNode
	| parentVis edge|
	parentVis := self addNode: self node parent atPosition: self class parentNodePosition.
	parentVis hideContent.
	
	edge := self drawEdgeFrom: self class parentConnectorStart 
		to: self class parentConnectorEnd.
		
	(self getVisualNodeFor: self node) parentEdge: edge.
	self addMorph: edge.
	parentVis childEdges add: edge.
	parentVis on: #click send: #clickUp to: self.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 12:16:50.62'!
drawRightChild
	| edge|
	rightMorph := self addNode: self node rightChild 
		atPosition: self class rightChildPosition.
	
	rightMorph isBlank ifTrue: [
		rightMorph parent: (self getVisualNodeFor: self node).
		rightMorph parentChildNumber: 2.	
	] ifFalse: [
		rightMorph hideContent.
		rightMorph on: #click send: #clickRight to: self.
	].
	
	edge := self drawEdgeFrom: self class childrenConnectorStart 
		to: self class rightConnectorEnd.
		
	rightMorph parentEdge: edge.
	self addMorph: edge.
	
	(self getVisualNodeFor: self node) childEdges add: edge.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/22/2013 12:38:35.348'!
drawThen: aBlock
	"self submorphs do: [:ea |  
		ea fadeOut ]."
	| oldMorphs done |
	oldMorphs := self submorphs copy.
	
	leftMorph := nil.
	rightMorph := nil.
	
	self drawCurrentNode.
	
	(self node leftChild isNil not or: self drawNil) ifTrue: [
		self drawLeftChild.
	].
	
	(self node rightChild isNil not or: self drawNil) ifTrue: [
		self drawRightChild.
	].
	
	self node parent ifNotNil: [
		self drawParentNode.
	].

"	self submorphs do: [:ea | (oldMorphs indexOf: ea) = 0 ifFalse: [ ea fadeIn ]]."
	done := false.
	(self submorphs difference: oldMorphs) do: [:ea | ea fadeInThen: [
			done ifFalse: [
				oldMorphs do: [:oldMorph | oldMorph delete.].
				aBlock value.
			].
			done := true.
			].].

	self extent: 100@160.! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'benjamin.siegmund 6/22/2013 12:47:59.284'!
fadeOutNode: aNode then: aBlock ifNot: callbackSet

	aNode ifNotNil: [
		callbackSet
			ifTrue: [aNode fadeOut]
			ifFalse:[aNode fadeOutThen: aBlock].
		(aNode edges) do: [ :edge | edge fadeOut].
		^ true].
	
	^ callbackSet! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/5/2013 17:41:43.66'!
finishGoLeftThen: aBlock

	self node: self node leftChild.
	self drawThen: aBlock.! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 12:48:30.578'!
finishGoRightThen: aBlock

	self node: self node rightChild.
	self drawThen: aBlock.! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'sebastian.stamm 6/12/2013 13:55:11.985'!
finishGoUpThen: aBlock

	self node: self node parent.
	self drawThen: aBlock.! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'dustin.glaeser 6/22/2013 12:33:07.462'!
goLeft
	
	self goLeftThen: [].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'benjamin.siegmund 6/22/2013 12:52:19.067'!
goLeftThen: aBlock
	| callbackSet |
	
	self node leftChild ifNil: [^ self].
	
	self actionPerformed.
	callbackSet := false.
	callbackSet := self fadeOutNode: (self getVisualNodeFor: self node parent) 
		then: [self animateGoLeftThen: aBlock.] ifNot: callbackSet.
	callbackSet := self fadeOutNode: rightMorph 
		then: [self animateGoLeftThen: aBlock.] ifNot: callbackSet.
		
	callbackSet ifFalse: [self animateGoLeftThen: aBlock.].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'dustin.glaeser 6/22/2013 12:34:05.301'!
goRight
	
	self goRightThen: [].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'benjamin.siegmund 6/22/2013 12:52:32.675'!
goRightThen: aBlock
	| callbackSet | 
	
	self node rightChild ifNil: [^ self].
	
	self actionPerformed.
	callbackSet := false.
	callbackSet := self fadeOutNode: (self getVisualNodeFor: self node parent) 
		then: [self animateGoRightThen: aBlock] ifNot: callbackSet.
	callbackSet := self fadeOutNode: leftMorph  
		then: [self animateGoRightThen: aBlock] ifNot: callbackSet.
		
	callbackSet ifFalse: [self animateGoRightThen: aBlock].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'dustin.glaeser 6/22/2013 12:34:15.797'!
goUp
	
	self goUpThen: [].! !

!I2STreeSectionMorph methodsFor: 'visualTransition' stamp: 'benjamin.siegmund 6/22/2013 12:52:42.825'!
goUpThen: aBlock
	| callbackSet | 
	
	self node parent ifNil: [^ self].
	
	self actionPerformed.
	callbackSet := false.
	callbackSet := self fadeOutNode: leftMorph  
		then: [self animateGoUpThen: aBlock] ifNot: callbackSet.
	callbackSet := self fadeOutNode: rightMorph
		then: [self animateGoUpThen: aBlock] ifNot: callbackSet.
		
	callbackSet ifFalse: [self animateGoUpThen: aBlock].! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/5/2013 16:14:56.008'!
initialize
	super initialize.
	self color: Color transparent.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 17:47:21.871'!
leftMorph
	^ leftMorph! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/29/2013 11:32:06.562'!
node
	^node! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/5/2013 14:54:01.091'!
node: aNode
	node := aNode.
	self draw.
	self valueSelected: aNode value.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 17:47:30.521'!
rightMorph
	^ rightMorph	! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:18:17.805'!
setRootNode: aNode
	self node: aNode.! !

!I2STreeSectionMorph methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 15:55:12.726'!
updateTree
"not relevant for this visualization class"
	^ self! !

!I2SVisualization class methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 14:39:48.544'!
newWithNode: aNode

  	|a visNode |
  	a := self new.
	a setRootNode: aNode.
	
	^a
  ! !

!I2SVisualization class methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 17:39:31.436'!
padding
	^50.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 14:18:05.838'!
actionPerformed
	self emit.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 15:47:54.719'!
activeNode
	^activeNode.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 15:47:55.752'!
activeNode: aNode
	activeNode := aNode.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:22:10.297'!
addedChild: aNode to: aParent at: aPosition

	self updateTree.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 18:04:05.205'!
animateToNewNodePositions: aNode left: aBoolean then: aBlock
	| newVis callbackCounter |
	callbackCounter := 0.
	self hideEdgesForNodeRotation: aNode left: aBoolean then: [
		newVis := self class newWithNode: self rootNode.
		"iterate over own visnodes"
		visualNodeMap do: [:ea ||dataNode newVisNode|
			"get the data node for the visual node"
			dataNode := ea node.
			"find the corresponding visual node in the new tree"
			newVisNode := newVis getVisualNodeFor: dataNode.
		
			"animate the position of the current node to the new position"
			ea walkToPosition: (newVisNode position + self position) then: [
				callbackCounter := callbackCounter + 1.
				callbackCounter = visualNodeMap size ifTrue: [
					self updateTree.
					newVis teardownConnections.
					aBlock value.
					Smalltalk garbageCollect.
				].
			].
		].
	].
	
	! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 14:14:02.217'!
choseLeaf: aVIsualBlankNode
	self actionPerformed.
	self emitAlways.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 18:23:02.42'!
clickedOn: aNode
	((self ignoreSelection not) and: (self ignoreMouse not)) ifTrue: [ | oldNode |
		oldNode := (self getVisualNodeFor: self activeNode). 
		self activeNode: aNode node.
		oldNode ifNotNil: [
			oldNode updateColor.
		].
		aNode updateColor.
		self addMorph: self rotationHandle.
		self rotationHandle position:
			((aNode position x + (aNode extent x / 2) - (self rotationHandle extent x /2)) @ aNode position y).
	]! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 17:41:20.953'!
drawDepthLineAt: aNumber
	| y aNode line |
	self rootNode ifNil: [^self].
	aNode := self getVisualNodeFor: rootNode.
	y := (aNumber * (aNode extent y)) + ((aNumber - 0.5) * aNode class levelHeight) + self class padding.
	line := (LineMorph 
		from: (0@y + self position) 
		to: (self extent x@y + self position)
		color: Color blue 
		width: 2).
	self addMorph: line.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/22/2013 11:57:49.321'!
drawNil
	^drawNil! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/22/2013 11:58:03.526'!
drawNil: aBoolean
	drawNil := aBoolean.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:52.204'!
getVisualNodeFor: aTreeNode

	^visualNodeMap at: aTreeNode ifAbsent: nil! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 17:57:37.041'!
hideEdgesForNodeRotation: aNode left: aBoolean then: aBlock
	|visNode|
	visNode := self getVisualNodeFor: aNode.
	visNode parentEdge ifNotNil: [
		visNode parentEdge fadeOut.
	].
	
	aBoolean ifTrue: [
		|rightChild|
		(visNode childEdges at: 2) fadeOutThen: aBlock.
		aNode rightChild ifNotNil: [
			rightChild := aNode rightChild.
			((self getVisualNodeFor: rightChild) parentEdge) fadeOut.
		].
		
	] ifFalse: [
		|leftChild|
		(visNode childEdges at: 1) fadeOutThen: aBlock.
		aNode leftChild ifNotNil: [
			leftChild := aNode leftChild.
			((self getVisualNodeFor: leftChild) parentEdge) fadeOut.
		].
	]
	! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 10:52:20.539'!
ignoreMouse
	^ignoreMouse! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/22/2013 10:52:01.367'!
ignoreMouse: aBoolean
	ignoreMouse := aBoolean.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:34:59.783'!
ignoreSelection
	^ignoreSelection! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:34:58.552'!
ignoreSelection: aBoolean
	ignoreSelection := aBoolean.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 16:49:39.306'!
initialize 
	super initialize.
	visualNodeMap := Dictionary new.
	self ignoreMouse: false.
	self ignoreSelection: true.
	self drawNil: false.
	color := Color transparent.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 18:20:54.05'!
initializeRotationHandle
	| handle l r |
	handle := Morph new.
	handle fillStyle: Color transparent.
	
	l := UiPushButton new.
	l text: 'LEFT'.
	handle addMorph: l.
	self connect: l signal: #clicked: toSelector: #rotateLeft.
	
	r := UiPushButton new.
	r text: 'RIGHT'.
	r position: 80@0.
	handle addMorph: r.
	self connect: r signal: #clicked: toSelector: #rotateRight.

	handle extent: ((r width + 80)@r height).
	
	self addMorph: handle.
	self rotationHandle: handle.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 14:51:25.32'!
maxDepth
	^maxDepth.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 14:51:26.378'!
maxDepth: aNumber
	maxDepth := aNumber.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:33:12.866'!
removedChild: aNode from: aParent at: aPosition

	self updateTree.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:46:55.22'!
rootNode
	^rootNode! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 12:11:04.226'!
rootNode: aNode
	rootNode := aNode.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 17:46:02.371'!
rootNodeChangeTo: aNode
	self teardownConnections.
	self rootNode: aNode.
	self setupConnections.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 18:18:40.289'!
rotateLeft
	self activeNode rotateLeft.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 17:40:05.44'!
rotateLeft: aNode then: aBlock
	self animateToNewNodePositions: aNode left: true then: aBlock.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 18:18:53.962'!
rotateRight
	self activeNode rotateRight.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 17:35:31.12'!
rotateRight: aNode then: aBlock
	self animateToNewNodePositions: aNode left: false then: aBlock.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 18:10:03.231'!
rotationHandle
	rotationHandle ifNil: [self initializeRotationHandle.].
	^rotationHandle! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/26/2013 17:58:44.976'!
rotationHandle: aMorph
	rotationHandle := aMorph.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 18:47:23.832'!
setRootNode: aRoot
	| visNode |
	"this is here to improve performance and to prevent image crashing"
	self teardownConnections.
	self rootNode: aRoot.

  	visNode := (I2SVisualNode newWithNode: aRoot on: self).
  	self addMorph: visNode.
	visNode visualization: self.
  	self extent: (visNode fullBounds extent + (2 * self class padding)).
	visNode position: visNode position - self fullBounds topLeft + self position + self class padding.
	visualNodeMap at: aRoot put: visNode .

 	self setupConnections.
  	^self! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 14:33:29.818'!
setVisualNode: aVisNode for: aTreeNode

	visualNodeMap at: aTreeNode put: aVisNode.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 17:42:06.269'!
setupConnections

	self connect: self rootNode signal: #addedChild:to:at: toSelector: #addedChild:to:at:.
	self connect: self rootNode signal: #removedChild:from:at: toSelector: #removedChild:from:at:.
	self connect: self rootNode signal: #willRotateTo: toSelector: #rootNodeChangeTo:.
	
	((self rootNode class = I2SBinaryTreeNode) or: (I2SBinaryTreeNode allSubclasses includes: self rootNode class)) ifTrue: [
		self connect: self rootNode signal: #rotatedLeft:then: toSelector: #rotateLeft:then:.
		self connect: self rootNode signal: #rotatedRight:then: toSelector: #rotateRight:then:.
	].! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 18:02:51.923'!
teardownConnections

	self rootNode disconnectSignal: #addedChild:to:at: from: self.
	self rootNode disconnectSignal: #removedChild:from:at: from: self.
	self rootNode disconnectSignal: #rotatedLeft:then: from: self.
	self rootNode disconnectSignal: #rotatedRight:then: from: self.
	self rootNode disconnectSignal: #willRotateTo: from: self.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/26/2013 14:53:04.573'!
updateTree
	| visNode |
	self removeAllMorphs.
	self setRootNode: self rootNode.
	self maxDepth ifNotNil: [
		self drawDepthLineAt: self maxDepth.
	].! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 6/26/2013 14:18:15.278'!
valueSelected: aValue
	self emit.! !

!I2SVisualization methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 18:54:42.404'!
visualNodeMap
	
	^visualNodeMap! !

AnimPropertyAnimation subclass: #I2SColorAnimation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SColorAnimation methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/23/2013 18:46:38.061'!
currentValue
	| c v o |
	Transcript showln: 'calculating current value'.
	v := self
		interpolatedFrom: 0
		to: 1
		progress: self currentLoopTime asFloat / ((self duration - 1) max: 1).
	o := self offset.
	
	(self startValue = Color transparent) ifTrue: [
		c := Color
			r: self endValue red
			g: self endValue green
			b: self endValue blue
			alpha: ((self startValue alpha * (1-v)) + (self endValue alpha * v)).
	].
	
	(self endValue = Color transparent) ifTrue: [
		c := Color
			r: self startValue red
			g: self startValue green
			b: self startValue blue
			alpha: ((self startValue alpha * (1-v)) + (self endValue alpha * v)).
	].
	
	((self startValue ~= Color transparent) and: (self endValue ~= Color transparent)) ifTrue:[	
		c := Color
			r: ((self startValue red * (1-v)) + (self endValue red * v))
			g: ((self startValue green * (1-v)) + (self endValue green * v))
			b: ((self startValue blue * (1-v)) + (self endValue blue * v))
			alpha: ((self startValue alpha * (1-v)) + (self endValue alpha * v)).
	].
		
	c := Color
		r: (c red + (o ifNil: [0] ifNotNil: [o red]))
		g: (c green + (o ifNil: [0] ifNotNil: [o green]))
		b: (c blue + (o ifNil: [0] ifNotNil: [o blue]))
		alpha: (c alpha + (o ifNil: [0] ifNotNil: [o alpha])).
		
	^ c! !

TestCase subclass: #I2SListMorphTests
	instanceVariableNames: 'list listMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:14:14.592'!
setUp
	| r |
	super setUp.
	r := Random new.
	list := r next: 20.
	listMorph := I2SListMorph newWithList: list.
	listMorph draw.
	listMorph openInWorld.! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:14:12.975'!
tearDown
	super tearDown.
	listMorph delete.! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:14:32.564'!
test01length
	self assert: 20 equals: (listMorph submorphs size).
	self assert: list equals: listMorph list.! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:20:37.887'!
test02values
	(1 to: 20) do: [:i|
			self assert: (list at: (21 - i)) equals: ((listMorph submorphs at: i) value).
			self assert:
				((20-i) * (I2SListElementMorph new defaultBounds width))
				equals:
				(((listMorph submorphs at: i) position x) - (listMorph position x)).
	].! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:21:04.968'!
test03highlighting
	| m |
	m := listMorph submorphs at: 5.
	m onMouseEnter.
	self assert: Color yellow muchLighter equals: m color.
	m onMouseLeave.
	self assert: Color white equals: m color.! !

!I2SListMorphTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/30/2013 17:21:50.567'!
test04uncovering
	| m m2|
	m := listMorph submorphs at: 5.
	m2 := listMorph submorphs at: 17.
	self assert: Color transparent equals: m submorphs first color.
	self assert: Color transparent equals: m2 submorphs first color.
	m onClick.
	self assert: Color black equals: m submorphs first color.
	self assert: Color transparent equals: m2 submorphs first color.
	self assert: m equals: listMorph activeElement.
	m2 onClick.
	self assert: Color transparent equals: m submorphs first color.
	self assert: Color black equals: m2 submorphs first color.
	self assert: m2 equals: listMorph activeElement.
	m2 onClick.
	self assert: Color transparent equals: m submorphs first color.
	self assert: Color transparent equals: m2 submorphs first color.! !

TestCase subclass: #I2STaskUiTests
	instanceVariableNames: 'task ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2STaskUiTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 15:12:36.603'!
setUp
	super setUp.
	task := I2STestTask new.
	task description: 'This is a test Task.'.
	task hints: OrderedCollection new.
	task addHint: 'This is Hint number 1.'.
	task addHint: 'This is Hint number 2.'.
	ui := I2SActiveTaskUi newWithTask: task.
	ui panel openInWorld.! !

!I2STaskUiTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 15:12:49.876'!
tearDown
	super tearDown.
	ui panel delete.! !

!I2STaskUiTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 15:12:57.767'!
test01Description
	self assert: task description equals: ui taskDescription theText string.! !

!I2STaskUiTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 6/19/2013 15:13:28.696'!
test02Hints
	ui hintButton doClick.
	self assert: (task hints at: 1) equals:(ui taskDescription theText string lines at: 2).
	ui hintButton doClick.
	self assert: (task hints at: 2) equals:(ui taskDescription theText string lines at: 3).
	ui hintButton doClick.
	self assert: (task hints at: 1) equals:(ui taskDescription theText string lines at: 4).! !

TestCase subclass: #I2STreeNodeTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 16:18:11.279'!
setUp
	super setUp.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 16:26:52.118'!
tearDown
	super tearDown.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 12:45:48.174'!
test01Initialisation
	| a |
	a := I2STreeNode newWithValue: #a.
	self assert: #a equals: (a getValueAt: 1).
	self assert: (a hasChildren) not.
	self assert: 0 equals: (a numChildren).! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 13:54:01.813'!
test02Limits
	| a |
	a := I2STreeNode new.
	a maxChildren: 2.
	a maxValues: 1.
	
self should: [a getValueAt: 0] raise: Error.
self shouldnt: [a getValueAt: 1] raise: Error.
self should: [a getValueAt: 2] raise: Error.
self should: [a setValue: 0 at: 0] raise: Error.
self shouldnt: [a setValue: 0 at: 1] raise: Error.
self should: [a setValue: 0 at: 2] raise: Error.
self should: [a getChildAt: 0] raise: Error.
self shouldnt: [a getChildAt: 1] raise: Error.
self shouldnt: [a getChildAt: 2] raise: Error.
self should: [a getChildAt: 3] raise: Error.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/5/2013 17:31:14.94'!
test03Children
	| a b c |
	a := I2STreeNode new.
	b := I2STreeNode new.
	c := I2STreeNode new.
	
	a addChild: b at: 1.
	self assert: b equals: (a getChildAt: 1).
	a addChild: c at: 2.
	self assert: c equals: (a getChildAt: 2).
	self assert: a equals: (b parent).
	self assert: a equals: (c parent).
	
	a removeChildAt: 1.
	self assert: ((a getChildAt: 1) isNil).
	self assert: (b parent isNil).
	self assert: c equals: (a getChildAt: 2).
	self assert: a equals: (c parent).
	a removeChildAt: 2.
	self assert: (a getChildAt: 2) isNil.
	self assert: c parent isNil.
	
	! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/8/2013 13:57:07.369'!
test04ChildrenAndLimits
	| a b |
	a := I2STreeNode new.
	b := I2STreeNode new.
	a maxChildren: 1.
	
	self should: [ a addChild: b at: 0] raise: Error.
	self should: [ a addChild: b at: 2] raise: Error.
	self shouldnt: [ a addChild: b at: 1] raise: Error.
	
	self should: [a removeChildAt: 0] raise: Error.
	self should: [a removeChildAt: 2] raise: Error.
	self shouldnt: [a removeChildAt: 1] raise: Error.
	! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 14:29:06.552'!
test05BinaryTree
	| a b c |
	a := I2SBinaryTreeNode newWithValue: 5.
	self assert: 1 equals: a maxValues.
	self assert: 2 equals: a maxChildren.
	self assert: 5 equals: a value.
	
	b := I2SBinaryTreeNode newWithValue: 3.
	c := I2SBinaryTreeNode newWithValue: 7.
	
	a leftChild: b.
	self assert: b equals: a leftChild.
	a leftChild: c.
	self assert: c equals: a leftChild.
	a rightChild: b.
	self assert: b equals: a rightChild.
	
	c value: 8.
	self assert: 8 equals: c value.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/15/2013 15:16:59.938'!
test06BinarySearchTree
	| root |
	root := I2SBinarySearchTreeNode newWithValue: 5.
	root addValue: 3.
	root addValue: 7.
	root addValue: 14.
	root addValue: 4.
	
	self assert: 5 equals: root value.
	self assert: 3 equals: root leftChild value.
	self assert: 7 equals: root rightChild value.
	self assert: 14 equals: root rightChild rightChild value.
	self assert: (root leftChild leftChild) isNil.
	self assert: (root rightChild leftChild) isNil.
	self assert: (root find: 5).
	self assert: (root find: 7).
	self assert: (root find: 3).
	self assert: (root find: 14).
	self assert: (root find: 4).
	self assert: (root find: 20) not.
	self assert: (root find: 10) not.
	self assert: (root find: 0) not.! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 17:51:31.112'!
test07RandomBinaryTree
	| tree |
	tree := I2SBinaryTreeNode randomTree.
	self assert: (tree numChildren >= 1).! !

!I2STreeNodeTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 17:52:41.675'!
test08RandomBinarySearchTree
	| tree |
	tree := I2SBinarySearchTreeNode randomTree.
	self assert: (tree numChildren >= 1).! !

TestCase subclass: #I2STreeSectionMorphTests
	instanceVariableNames: 'vis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2STreeSectionMorphTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 17:11:15.53'!
setUp
	super setUp.
	vis := I2STreeSectionMorph new.! !

!I2STreeSectionMorphTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/30/2013 17:11:12.372'!
tearDown
	vis delete.
	super tearDown.! !

!I2STreeSectionMorphTests methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 6/12/2013 14:09:34.67'!
testNavigation
	| root left right |
	root := I2SBinaryTreeNode new.
	root value: 3.
	
	left := I2SBinaryTreeNode new.
	left value: 5.
	root leftChild: left.
	
	right := I2SBinaryTreeNode new.
	right value: 4.
	root rightChild: right.
	
	(vis node: root) openInWorld.
	
	self assert: 5 equals: vis submorphs size.
	"we can't use assertions in the callback, because the image will freeze."
	vis goRightThen: [vis goUpThen: [vis goRight.].].
! !

TestCase subclass: #I2SVisualizationTests
	instanceVariableNames: 'visualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching-Tests'!

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:50:14.849'!
setUp
	
	super setUp.
	visualization := I2SVisualization new. 
	! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 11:44:04.316'!
tearDown
	
	visualization delete.
	super tearDown! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dg 5/8/2013 14:28:54.794'!
test01SimpleTree
	| a b c |
	a := I2STreeNode new.
	a setValue: Color red at: 1.

	b := I2STreeNode new.
	b setValue: Color blue at: 1.

	c := I2STreeNode new.
	c setValue: Color blue at: 1.

	a addChild: b at: 1.
	a addChild: c at: 2.

	(visualization setRootNode: a)	openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:32:18.954'!
test02UpdateTree

	| root child |
	root := I2STreeNode new.
	
	(visualization setRootNode: root) openInWorld.
	
	child := I2STreeNode new.
	
	root addChild: child at: 1.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:30:58.813'!
test03RemoveChild

	| root child |
	root := I2STreeNode new.
			
	child := I2STreeNode new.
	
	root addChild: child at: 1.
	
	(visualization setRootNode: root) openInWorld.
		
	root removeChildAt: 1.
! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/15/2013 16:29:32.808'!
test04MoarDepth
	| a b c d |
	a := I2STreeNode new.

	b := I2STreeNode new.

	c := I2STreeNode new.
	
	d := I2STreeNode new.

	a addChild: b at: 1.
	a addChild: c at: 2.
	b addChild: d at: 1. 
	
	(visualization setRootNode: a) openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/29/2013 16:40:37.672'!
test05ComplexTree

| a b c d e f |
	a := I2STreeNode new.
	a color: Color red.

	b := I2STreeNode new.
	b color: Color blue.

	c := I2STreeNode new.
	c color: Color blue.

	d := I2STreeNode new.
	e := I2STreeNode new.
	f := I2STreeNode new.

	a addChild: b at: 1.
	a addChild: c at: 2.
	b addChild: d at: 1. 
	b addChild: e at: 2.
	c addChild: f at: 1.

	(visualization setRootNode: a) openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 15:41:25.401'!
testBuildBinaryTreeFromRoot

	| root nodeOne nodeTwo |
	root := I2SBinaryTreeNode new.
	nodeOne := I2SBinaryTreeNode new.
	nodeTwo := I2SBinaryTreeNode new.
	
	root color: Color red.
	
	root rightChild: nodeOne.
	nodeOne rightChild: nodeTwo.
	
	(visualization setRootNode: root) openInWorld.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 15:47:17.087'!
testDefaultColor
	
	| node description|
	node := I2STreeNode new.
	visualization setRootNode: node.
	
	description := 'Every node needs a default color for visualization.'.
	self assert: 
		[(visualization getVisualNodeFor: node) color = Color orange]
		description: description.! !

!I2SVisualizationTests methodsFor: 'as yet unclassified' stamp: 'dustin.glaeser 5/29/2013 15:39:33.432'!
testVisualizationAssignment

	| root child child2 child3 aTreeNode|
	
	root := I2STreeNode new.
	child := I2STreeNode new.
	child2 := I2STreeNode new.
	child3 := I2STreeNode new.
	
	root addChild: child at: 1.
	root addChild: child2 at: 2.
	child2 addChild: child3 at: 1.
	
	(visualization setRootNode: root) openInWorld.
	self assert: (visualization submorphs at: 1) 
		equals: (visualization getVisualNodeFor: root).

	"Is there a better, more stable way to test this?"
	self assert: ((visualization getVisualNodeFor: root) 
						submorphs at: 4)
		equals: (visualization getVisualNodeFor: child).
	
	self assert: (((visualization getVisualNodeFor: root)
						submorphs at: 2) submorphs at: 2)
		equals: (visualization getVisualNodeFor: child3).
	
	"less moph-structure dependent approach"
	aTreeNode := (visualization getVisualNodeFor: child3) node.
	self assert: root equals: 
		aTreeNode parent parent.
	
	! !
